;****************************************************************
;display communication subs
;****************************************************************



;display init
_initDIS:
		call	RDbusy	;busy-flag lesen
		ldi	r20,IdisON	;beide display hlften on
		call	WRinstr	;write instruction 
		call	RDbusy	;busy-flag lesen
	
		;set display-ram startadressen
		ldi	r20,IpageADR	
		call	WRinstr	;page adresse =0
		call	RDbusy
		;						
		ldi	r20,IyADR
		call	WRinstr	;y-line-adresse =0
		call	RDbusy
		;				
		ldi	r20,IstLINE
		call	WRinstr	;x-line-adresse =0
		call	RDbusy
		;
		;starte mit linker displayhlfte...
		clr	r20
		sts	xPOSabs,r16
		ldi	r20,IleftYpage
		call	WRnewYpage		;y-adresse =0
		call	RDbusy
		ret

;***********************************************************************

;read busy-flag
RDbusy:
	ldi	r16,0
	out	ddra,r16	;porta input
	cbi	portc,Dena	;enable low
	call	wt5cycle	;einige cycles warten...
	in	r16,portc
	andi	r16,0xcf	;0xbd	;nur d/i und w/r ausblenden
	ori	r16,0x20	;0x2	;d/i=0  w/r=1
	out	portc,r16
RDbusyGO:
	call	wt5cycle	;einige cycles warten...
	sbi	portc,Dena	;enable high
	call	wt5cycle	;einige cycles warten...
	in	r16,pina	;port-data lesen
	cbi	portc,Dena	;enable low
	sbrc	r16,Dbusy	;0=not busy
	rjmp	RDbusyGO	;1=busy
	ret

;***************************************************************
;
;write instruction
WRinstr:
	ldi	r16,0xff
	out	ddra,r16	;porta output
	;test
	cbi	portc,Dena	;enable low
	;
	call	wt5cycle	;einige cycles warten...
	in	r16,portc
	andi	r16,0xcf	;0xbd	;nur d/i und w/r ausblenden
	ori	r16,0			;d/i=0  w/r=0
	out	portc,r16
	call	wt5cycle	;einige cycles warten...
	sbi	portc,Dena	;enable high
	out	porta,r20	;port-data schreiben
	call	wt5cycle	;einige cycles warten...
	cbi	portc,Dena	;enable low
	;
	ret

;***************************************************************

;write instruction new y-page & y-adesss=0
WRnewYpage:
	ldi	r16,0xff
	out	ddra,r16	;porta output
	;test
	cbi	portc,Dena	;enable low
	;
	call	wt5cycle	;einige cycles warten...
	in	r16,portc
	andi	r16,0xf	;0xb1	; d/i und w/r  cs1 & cs2 ausblenden
	or	r16,r20	;d/i=0  w/r=0 
	out	portc,r16
	call	wt5cycle	;einige cycles warten...
	sbi	portc,Dena	;enable high
	lds	r16,xPOSabs
	;adressiere y-spalte
	cpi	r16,64
	brlo	_WRnewYpageX
	subi	r16,64
_WRnewYpageX:
	ldi	r20,IyADR
	add	r20,r16
	out	porta,r20	;port-data schreiben
	call	wt5cycle	;einige cycles warten...
	cbi	portc,Dena	;enable low
	;
	ret


;*************************************************************
;
;write data
WRdata:
	ldi	r16,0xff
	out	ddra,r16	;porta output
	;test
	cbi	portc,Dena	;enable low
	;
	call	wt5cycle	;einige cycles warten...
	in	r16,portc
	andi	r16,0xcf	;0xbd	;nur d/i und w/r ausblenden
	ori	r16,0x10	;40		;d/i=1  w/r=0
	out	portc,r16
	call	wt5cycle	;einige cycles warten...
	sbi	portc,Dena	;enable high
	out	porta,r20	;port-data schreiben
	call	wt5cycle	;einige cycles warten...
	cbi	portc,Dena	;enable low
	;	
	ret

;*************************************************************
;hier dummy read einbauen....
;read data
RDdata:
	clr	r16
	out	ddra,r16	;porta input
	cbi	portc,Dena	;enable low
	call	wt5cycle	;einige cycles warten...
	in	r16,portc
	andi	r16,0xcf	;bd	;nur d/i und w/r ausblenden
	ori	r16,0x30	;0x42		;d/i=1  w/r=1
	out	portc,r16
	call	wt5cycle	;einige cycles warten..
	;read...
	sbi	portc,Dena	;enable high
	call	wt5cycle	;einige cycles warten...
	in	r20,pina	;port-data holen
	cbi	portc,Dena	;enable low
	;
	ret



;*************************************************************
;SUB read page
;r10=daten
;r11=page adress
;*************************************************************
_RDdisplayPAGE:
	;page-range prfen...
	mov	r19,r11
	cpi	r19,displayPAGEmax	;max. page-range f. dieses display
	brlo	_GRAPHrdAX
	jmp	_RDdisplayHOME
_GRAPHrdAX:
	;y-spaltenadresse 
	lds	r19,xPOSabs	;absolute x-position laden
	cpi	r19,64
	brlo	_GRAPHwrA
	subi	r19,64
_GRAPHwrA:
	ldi	r20,IyADR
	add	r20,r19
	call	WRinstr	;instruction zum glcd
	call	RDbusy	;busy...

	;lese x-page-daten von display
	;von firstPAGE adresse	
	ldi	r20,IpageADR
	add	r20,r11	;add last page adress
	call	WRinstr	;instruction zum glcd
	call	RDbusy	;busy...
	;dummy...
	call	RDdata	;lese daten
	mov	r10,r20	;daten nach r15 sichern
	call	RDbusy	;busy...
	;lese.
	call	RDdata	;lese daten
	mov	r10,r20	;daten nach r15 sichern
	call	RDbusy	;busy...

	;y-spaltenadresse korrigieren
	lds	r19,xPOSabs	;absolute x-position laden
	cpi	r19,64
	brlo	_GRAPHwrB
	subi	r19,64
_GRAPHwrB:
	ldi	r20,IyADR
	add	r20,r19
	call	WRinstr	;instruction zum glcd
	call	RDbusy	;busy...
_RDdisplayHOME:
	ret







;*************************************************************
;SUB write page 
;r10=daten
;r11=page adress
;*************************************************************
_WRdisplayPAGE:
	;page-range prfen...
	mov	r19,r11
	cpi	r19,displayPAGEmax	;max. page-range f. dieses display
	brlo	_GRAPHwrCX
	jmp	_WRdisplayHOME
_GRAPHwrCX:
	;adressiere y-spalte
	lds	r19,xPOSabs	;absolute x-position laden
	cpi	r19,64
	brlo	_GRAPHwrC
	subi	r19,64
_GRAPHwrC:
	ldi	r20,IyADR
	add	r20,r19
	call	WRinstr	;instruction zum glcd
	call	RDbusy	;busy...
	;
	;adressiere page...	
	ldi	r20,IpageADR
	add	r20,r11	;add first page adress
	call	WRinstr	;instruction zum glcd
	call	RDbusy	;busy...
	;
	;schreibe daten nach glcd...
	mov	r20,r10
	call	WRdata	;daten nach glcd
	call	RDbusy	;busy....
_WRdisplayHOME:
	ret





;****************************************************************
;wait-loop
;tested 11,059mhz
wt5cycle:
	ldi	r16,2
	wt5cycleLOOP:
		tst	r16
		breq	wt5cycleBK
		dec	r16
		rjmp	wt5cycleLOOP
		wt5cycleBK:
			ret


;*****************************************************************

