;*****************************************************************************************
;PLOTline    konstruktion und darstellung einer line (max.65 pix lnge)
;
;- im bereich liegende daten
;  knnen belassen oder komplett berschrieben
;  (auch lschen...) werden
;
;bentigte parameter:
;- txtBOxPOSabsXte = absolute x-koordinate (obere linke ecke)
;- txtBOxPOSabsYte = absolute y-koordinate (obere linke ecke)
;- lgtLINE	    = relative linienlnge
;- alphaLINE    = linienwinkel (30' schritte)
;- quadLINEfl   = flagvariable (plotquadrant)
;
;flags zu <quadLINEfl>:
;- PxMy	    = quadrant rechts oben (+x,-y)
;- PxPy	    = quadrant rechts unten(+x,+y)
;- MxPy	    = quadrant links unten (-x,+y)
;- MxMy	    = quadrant links oben  (-x,-y)
;
;weitere bentigte flags <graphBOXflTE>:	
;- graphBOXinv	0=normal / 1=invertiert		

;*****************************************************************************************

_PLOTline:
	;lade winkel der linie 
	lds	r16,alphaLINE
	sts	radCNT,r16
	;lade startlnge der linie
	clr	r16
	sts	radCIRCLE,r16
	;
	;koordinaten berechnen
_PLOTlineLOOP:
	call	_subCIRCLE		;koordinatenberechnung via (co)-sinustabelle
	;aktuelle plot-kordinaten
	;xPLOT,yPLOT	
	;-> quadranten berechnen
	lds	r16,quadLINEfl	;quadrantenflags laden
	lds	r17,graphBOXposXte	;absoluten x-ausgangspunkt laden
	lds	r18,graphBOXposYte	;absoluten y-ausgangspunkt laden
	lds	r19,xPLOT		;relative  x-koordinate laden
	lds	r20,yPLOT		;relative  y-koordinate laden
	;prfe flags...
	tst	r16
	brne	_PLOTlineQUADa
	jmp	_PLOTlineREADY	;flag fehlt - keine aktion !
	;
	;quadrant oben rechts?
_PLOTlineQUADa:
	sbrs	r16,PxMy		
	rjmp	_PLOTlineQUADb
	add	r17,r19	;absX + relX
	sts	xPOSabs,r17	;x-plotposition sichern
	sub	r18,r20	;absY - relY
	sts	yPOSabs,r18	;y-plotposition sichern
	call	_plotXY	;...plotten
	rjmp	_PLOTlineQUADgo
	;quadrant unten rechts?
_PLOTlineQUADb:
	sbrs	r16,PxPy		
	rjmp	_PLOTlineQUADc
	add	r17,r19	;absX + relX
	sts	xPOSabs,r17	;x-plotposition sichern
	add	r18,r20	;absY + relY
	sts	yPOSabs,r18	;y-plotposition sichern
	call	_plotXY	;...plotten
	rjmp	_PLOTlineQUADgo
	;quadrant unten links?
_PLOTlineQUADc:
	sbrs	r16,MxPy		
	rjmp	_PLOTlineQUADd
	sub	r17,r19	;absX - relX
	sts	xPOSabs,r17	;x-plotposition sichern
	add	r18,r20	;absY + relY
	sts	yPOSabs,r18	;y-plotposition sichern
	call	_plotXY	;...plotten
	rjmp	_PLOTlineQUADgo
	;quadrant oben links?
_PLOTlineQUADd:
	sbrs	r16,MxMy		
	rjmp	_PLOTlineQUADgo
	sub	r17,r19	;absX - relX
	sts	xPOSabs,r17	;x-plotposition sichern
	sub	r18,r20	;absY - relY
	sts	yPOSabs,r18	;y-plotposition sichern
	call	_plotXY	;...plotten
	rjmp	_PLOTlineQUADgo
	;
	;nun berechnung des nchsten 
	;plots vorbereiten
_PLOTlineQUADgo:
	;lade lnge der linie
	lds	r16,lgtLINE
	lds	r17,radCIRCLE
	cp	r16,r17
	brne	_PLOTlineNXT
	jmp	_PLOTlineREADY
_PLOTlineNXT:
	;radius +1 / winkel bleibt
	inc	r17
	sts	radCIRCLE,r17
	jmp	_PLOTlineLOOP	;...weiter
	;hier linienstrke prfen!
	;fertig !
_PLOTlineREADY:
	ret

	