


;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;graphische funktion: drwRECT(xpos,ypos,xsize,ysize,line,func)
;weitere varianten (func):
;- nur rechteckiger rahmen (inhalt berschreiben ODER belassen)
;- geflltes rechteck (inhalt berschreiben ODER invertiert darstellen)
;  -> kann auch zum kompletten lschen von bereichen herangezogen werden!

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;
;a)rechtwinkliges Rechteck konstruieren:
_DRWrectangle:
	;
	call	_CALCpageSIZ	;bentigten x-pagebereich fr txtBOX berechnen
					;& masken erstellen

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_DRWrectangleB:
	lds	r16,yCHARsiz
	lds	r17,graphBOXflTE

	;beschreibe 64-bit shift-register
	;-> *yCHARsize
_DRWrectangleBloop:
	tst	r16
	breq	_DRWrectangleC
	dec	r16
	set		;set t-flag
	call	_SFTregA
	jmp	_DRWrectangleBloop
		

_DRWrectangleC:
;	shift register inhalt, falls
;   	erforderlich verschieben
	lds	r16,SFTfactor	;shift-factor 0-7 laden
_DRWrectreadyLOOP:
	tst	r16
	breq	_DRWrectangleD
	clt
	dec	r16
	call	_SFTregA		;x*schieben
	jmp	_DRWrectreadyLOOP
	;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_DRWrectangleD:
	;zuerst shift-register ins sram
	;shiftregister startadresse
	ldi	zh,high(SFTregST)
	ldi	zl,low(SFTregST)
	st	z+,r2
	st	z+,r3
	st	z+,r4
	st	z+,r5
	st	z+,r6
	st	z+,r7
	st	z+,r8
	st	z,r9	


	




	;Rechteckrahmen darstellen
	;
_DRWrectangleE:
	;berechne erste page der y-spalte
	;-> alle pages im bereich mit aktuellen daten fllen & darstellen
	;-> vorgang entsprechend der linienstrke wiederholen
	;
	;lade linienstrke
	lds	r21,LINEth
	;
_DRWrectangleLOOPa:
	;spalten entsprechend der 
	;linienbreite zeichnen
	call	_DRWcolSUB
	dec	r21
	tst	r21
	brne	_DRWrectangleLOOPa


	;lade x-dimension
	lds	r22,xCHARsiz
	;lade x-origin
	lds	r23,graphBOXposXte
	;absolut x berechnen
	add	r22,r23
	;lade linienstrke
	lds	r23,LINEth
	;absolute breite - linienstrke
	sub	r22,r23
	;aktuelle absolute x-position speichern
	sts	xPOSabs,r22
	;
_DRWrectangleLOOPb:
	;spalten entsprechend der 
	;linienbreite zeichnen
	call	_DRWcolSUB
	dec	r23
	tst	r23
	brne	_DRWrectangleLOOPb
	jmp	_DRWrectangleCHK

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;prfe ob:
;a)bargraph-mode 
;b)volles rechteck 
;  ODER
;c)rechteckiger rahmen
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_DRWrectangleCHK:
	lds	r17,graphBOXflTE
	sbrc	r17,graphBOXbar	  ;0=normal
	rjmp	_DRWrectangleBAR	  ;1=bargraph
	sbrc	r17,graphBOXcont	  ;0=volles rechteck		
	rjmp	_DRWrectangleLOOPc  ;1=rechteckiger rahmen 
	jmp	_DRWrectreadyLOOPcx

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;bargraph
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_DRWrectangleBAR:
	;parameter fr bargraph holen
	;nach prozent konvertieren &
	;speichern
	lds	zl,paraA
	call	_d255iv
	sts	paraA,r1	;prozent speichern
	;xPOS berechnen
	lds	r16,graphBOXposXte
	lds	r22,LINEth
	add	r16,r22
	sts	xPOSabs,r16
	;prozent holen
	lds	r21,paraA
_DRWbarreadyLOOP:
	;spalten entsprechend der 
	;linienbreite zeichnen
	tst	r21
	breq	_DRWbarreadyLOOPxy
	call	_DRWcolSUB
	dec	r21
	jmp	_DRWbarreadyLOOP
	;
_DRWbarreadyLOOPxy:
	;bargraph fertig
	;rest leer....
	;	
	;txtBOSposXte berechnen
	;+parameter(%)
	lds	r16,graphBOXposXte
	lds	r21,paraA
	add	r16,r21
	sts	graphBOXposXte,r16
	;xcharSIZ berechnen
	;-parameter(%)
	lds	r16,xCHARsiz
	lds	r21,paraA
	sub	r16,r21
	sts	xCHARsiz,r16
	jmp	_DRWrectangleLOOPc

;--------------------------------------------------------------------

			;nun shift-register manipulieren
			;-> x-line zeichnen
		_DRWrectangleLOOPc:			
			lds	r22,LINEth
		_DRWrectangleLOOPd:
			tst	r22
			breq	_DRWrectangleLOOPe
			dec	r22
	set		;set t-flag
	call	_SFTregA
	jmp	_DRWrectangleLOOPd
			;
			;zwischenraum
		_DRWrectangleLOOPe:	

			lds	r16,yCHARsiz
			lds	r22,LINEth
			;charsiz - 2*lineth
			ldi	r24,2
			mul	r22,r24
			sub	r16,r0

			;beschreibe 64-bit shift-register
		_DRWrectangleLOOPf:
			tst	r16
			breq	_DRWrectangleLOOPg
			dec	r16
			clt		;clear t-flag
			call	_SFTregA
			jmp	_DRWrectangleLOOPf
			;
		_DRWrectangleLOOPg:
			lds	r22,LINEth
		_DRWrectangleLOOPh:
			tst	r22
			breq	_DRWrectangleLOOPj
			dec	r22

	set		;set t-flag
	call	_SFTregA
	jmp	_DRWrectangleLOOPh

		

				_DRWrectangleLOOPj:
				;	shift register inhalt, falls
				;   	erforderlich verschieben
					lds	r16,SFTfactor	;shift-factor 0-7 laden
				_DRWrectreadyLOOPb:
					tst	r16
					breq	_DRWrectreadyLOOPc
					clt
					dec	r16
					call	_SFTregA		;x*schieben
					jmp	_DRWrectreadyLOOPb




;x-linien zeichnen
_DRWrectreadyLOOPc:
	;zuerst shift-register ins sram
	;shiftregister startadresse
	ldi	zh,high(SFTregST)
	ldi	zl,low(SFTregST)
	st	z+,r2
	st	z+,r3
	st	z+,r4
	st	z+,r5
	st	z+,r6
	st	z+,r7
	st	z+,r8
	st	z,r9	


_DRWrectreadyLOOPcx:
	;xPOS berechnen
	lds	r16,graphBOXposXte
	lds	r22,LINEth
	add	r16,r22
	sts	xPOSabs,r16
	lds	r21,xCHARsiz
	ldi	r24,2
	mul	r22,r24	;lineth*2
	sub	r21,r0
	;	
_DRWrectreadyLOOPd:
	tst	r21
	breq	_GgraphMODready
	;spalten entsprechend der 
	;linienbreite zeichnen
	call	_DRWcolSUB
	dec	r21
	jmp	_DRWrectreadyLOOPd

_GgraphMODready:
	ret











;****************************************************************************************
;sub division 16bit/255  (zl parameter | %-result in r1
;****************************************************************************************
_d255iv:
.equ	T2550HOU	=	2550	
.equ	H255UN	=	255
.equ	H127UN	=	127
	;parameter x(8bit)*100
	lds	zl,paraA
	ldi	zh,100
	mul	zl,zh
	mov	zl,r0	;lsb
	mov	zh,r1	;msb
	;
	clr	r1	;10% er counter
	ldi	yl,low(T2550HOU)
	ldi	yh,high(T2550HOU)
	ldi	xl,10
	;wie oft gehn 2550 rein?
_THOloop:
	;>=2550
	cpi	zl,low(T2550HOU)	
	ldi	xh,high(T2550HOU)	
	cpc	zh,xh		
	brlo	_HUloop
	;-25550
	sub	zl,yl		;low
	sbc	zh,yh		;high
	add	r1,xl		;+10%
	rjmp	_THOloop
	;
	;wie oft gehn 255 rein
_HUloop:
	ldi	yl,low(H255UN)
	ldi	yh,high(H255UN)
	ldi	xl,1
_HUloopGO:
	;>=255
	cpi	zl,low(H255UN)	
	ldi	xh,high(H255UN)	
	cpc	zh,xh		
	brlo	_HUloopEX
	;-255
	sub	zl,yl		;low
	sbc	zh,yh		;high
	add	r1,xl		;+1000
	rjmp	_HUloopGO

	;rest >127 (dann %+1)
_HUloopEX:
	cpi	zl,low(H127UN)	
	ldi	xh,high(H127UN)	
	cpc	zh,xh		
	brlo	_HUloopREADY
	;>=127 == +1%
	inc	r1
_HUloopREADY:
	ret