;display graphic symbols / dynamische darstellung
;.....................................................
;graphische symbol-, funktionsauswahl (graphFU):
;
;_____________________________________________
;no function |1  |1  |1  |1  |1  |1  |1  |1  |
;____________|___|___|___|___|___|___|___|___|
;show ic_sym |0  |0  |0  |0  |1  |1  |1  |1  |
;____________|___|___|___|___|___|___|___|___|
;show wlanA  |0  |0  |0  |1  |1  |1  |1  |1  |
;____________|___|___|___|___|___|___|___|___|
;show wlanB  |0  |0  |1  |0  |1  |1  |1  |1  |
;____________|___|___|___|___|___|___|___|___|
;show wlanC  |0  |0  |1  |1  |1  |1  |1  |1  |
;____________|___|___|___|___|___|___|___|___|
;show wlanD  |0  |1  |0  |0  |1  |1  |1  |1  |
;____________|___|___|___|___|___|___|___|___|
; .
; .
; .
;_____________________________________________
;shift l/r   |x  |x  |x  |x  |0  |1  |1  |1  |
;____________|___|___|___|___|___|___|___|___|
;
;
;_____________________________________________
;show bigTXT |1  |1  |1  |1  |1  |0  |1  |1  |
;____________|___|___|___|___|___|___|___|___|
;
;
;_____________________________________________
;dyn  all sym|x  |x  |x  |x  |1  |1  |0  |1  |
;____________|___|___|___|___|___|___|___|___|

;.....................................................
;variablen:
;graphFU	=	graphische funktionsvariable
;graphFUte	=	temp. graph. variable
;GsymFL		=	gsym steuerflags
;GsymTIl	=   lower byte timer
;GsymTIh	=	higher byte timer
;Xshift		=	shift faktor (xpos+xshift)=aktuelle pos
;
;.....................................................
;flags (GsymFL)
;showSYM	=	0	;symbol darstellen (aus sysIF)
;dynSYM		=	1   ;dynamische symboldarstellung
;sftSYM		=	2	;symbol verschieben
;newSYM		=	3	;neues symbol darstellen /static mode
;.....................................................
;konstante
;ySYM		=	4	;4bytes pro spalte
;xSYM		=	36	;36 spalten



_Gsym:
	;gsym status prfen
	lds		r16,GsymFL
	sbrc	r16,showSYM	;1=symbol(e) darstellen
	rjmp	_G1sym
	jmp		_GsymBK
;.....................................................

_G1sym:
	;dynamische darstellung (all symbols / shift lr) ?
	sbrc	r16,dynSYM
	rjmp	_G10symX	;dynamische darstellung bereits aktiv
	sbrc	r16,sftSYM
	rjmp	_G20symX	;shifted darstellung bereits aktiviert
	sbrc	r16,newSYM
	rjmp	_G20symX	;symbol noch nicht fertig
	;graphFU laden & prfen
	sbr		r16,1<<newSYM
	sts		GsymFL,r16
	lds		r17,graphFU
	swap	r17	;nibbles tauschen
	andi	r17,0b00001111
	sts	graphFUte,r17	;sichern
				;
				;=0...6 (...pushbutton)
				cpi	r17,7
				brsh _GnoSYM
				jmp	_DISsym	;einzelnes symbol darstellen									;
								_GnoSYM:
									;>=7 nicht gltig
									clr	r16
									sts	GsymFL,r16
									jmp	_GsymBK

_G10symX:
	jmp	_G10sym
_G20symX:
	jmp	_G20sym




;.....................................................
;_DISsym  symbole darstellen
;.....................................................
_DISsym:
	;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	;displayfenster komplett lschen 
	;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	ldi	r16,1
	sts	graphBOXposXte,r16
	sts	xPOSabs,r16
	;
	ldi	r16,18
	sts	graphBOXposYte,r16
	sts	yPOSabs,r16
	;
	ldi	r16,126
	sts	xCHARsiz,r16
	;
	ldi	r16,34
	sts	yCHARsiz,r16
	;keine linie / kein rahmen
	ldi	r16,0
	sts	LINEth,r16
	;
	clr	r16
	;test
;	sbr	r16,1<<graphBOXcont 
	;
;	sbr	r16,1<<graphBOXfull
	sbr	r16,1<<graphBOXclr
	sbr	r16,1<<graphBOXinv
	sts	graphBOXflTE,r16
	call	_DRWrectangle
	;+++++++++++++++++++++++++
	;shift?
	lds		r17,graphFU
	sbrc	r17,3	;0=shift
	rjmp	_GDISnosft
	;+++++++++++++++++++++++++
	;xshift auf start (0)
	clr	r17
	sts	Xshift,r17
	lds	r16,GsymFL
	sbr	r16,1<<sftSYM	;1=shift
	;shift timer=0
	clr	r17
	sts	GsftTIl,r17
	sts	GsftTIh,r17
	;
	jmp	_GDISKO
	;+++++++++++++++++++++++++
	;xshift auf 30
_GDISnosft:
	ldi	r17,50
	sts	Xshift,r17
	lds	r16,GsymFL
	cbr	r16,1<<sftSYM
	;+++++++++++++++++++++++++
_GDISKO:
	sts	GsymFL,r16
	;startkoordinaten 
	ldi	r16,1
	sts	graphBOXposXte,r16
	;
	ldi	r16,19	;18
	sts	graphBOXposYte,r16
	sts	yPOSabs,r16
;	sts	xPOSabs,r17
	;charSIZE
	ldi	r16,36
	sts	xCHARsiz,r16
	;
	ldi	r16,32
	sts	yCHARsiz,r16
	;pagebereich berechnen
	call	_CALCpageSIZ	;bentigten x-pagebereich fr symBOX berechnen
	;relative x-startposition
	lds	r17,Xshift
	sts	xPOSabs,r17

	;+++++++++++++++++++++++++
	;symbolstartadresse berechnen
	;basis: 144 tabellenwerte pro symbol
	;start: ic_sym
	;berechnung: symbolnummer * 144 + icsym
	;(zl/zh) * (r16/r17)
	lds	r16,graphFUte	;symbolnummer
	clr	r17
	ldi	zh,high(symLARGE)	;144
	ldi	zl,low(symLARGE)
	;
	mul	 zl, r16	
	movw r7:r6, r1:r0
	mul	 zh, r16		
	add	 r7, r0
	mul	 r17, zl	
	add	 r7, r0
	;result r6(L)/r7(H)
	;neuer startpoint+startadresse=pointer
	ldi	zh,high(ic_sym*2)
	ldi	zl,low(ic_sym*2)
	add	zl,r6
	adc	zh,r7
	sts	symZpointL,zl		;pointer sichern
	sts	symZpointH,zh		; "        "
	;
	;+++++++++++++++++++++++++
	;dynamische darstellung ?
	lds		r17,graphFU
	sbrc	r17,1	;0=dyn all symbols
	rjmp	_GnodynX
	;ja...
	lds	r16,GsymFL
	sbr	r16,1<<dynSYM	;1=dyn symbol
	sts	GsymFL,r16
	;timer auf start (0)
	clr	r16
	sts	GsymTIAl,r16
	sts	GsymTIAh,r16
	sts	GsymTIBl,r16
	sts	GsymTIBh,r16
	jmp	_G10sym	;zur dynamischen symboldarstellung
	;++++++++++++++++++++++++++
_GnodynX:
	lds	r16,GsymFL
	cbr	r16,1<<dynSYM	;0=no dyn symbol
	sts	GsymFL,r16
	jmp	_G20sym	;zur shifted oder normaler symboldarstellung


;-----------------------------------------------------------------------------------------
;Dynamische Module
;-----------------------------------------------------------------------------------------
;dynamische darstellung
_G10sym:











;------------------------------------------------------------------------------------------
;shifted oder normaldarstellung
;------------------------------------------------------------------------------------------
_G20sym:
	clr	r16
	sts	SYMxSIZE,r16
	;erstmaliger aufruf?
	lds		r16,GsymFL
	sbrs	r16,newSYM	;1=erstmalig symbol darstellen
	rjmp	_G20CKsymSFT
	;erstmalige darstellung
	;= symbolstartadresse backup
	lds	zl,symZpointL	;berechneten pointer laden
	lds	zh,symZpointH
	sts	symZpointHte,zh	;pointer temporr speichern !
	sts	symZpointLte,zl
	jmp	_DRWsymB		;zur erstmaligen darstellung


	;......................................................


_G20CKsymSFT:
	;hier prfen ob shift oder normal?
	;bei shift:
	;a) shift-counter =sollwert ?
	;b) alten symbolbereich lschen
	;c) startadresse des symbols holen
	sbrc	r16,sftSYM	;1=shifted symbol darstellen
	rjmp	_G20symSFT
	;...not shifted == flags lschen
	clr	r16
	sts	GsymFL,r16
	jmp	_GsymBK	;und raus...
	;.....................................................
	;shifted....
	;shift time !!
	_G20symSFT:
		lds	zl,GsftTIl
		lds	zh,GsftTIh
		cpi	zl,low(sftTIME)
		ldi	r16,high(sftTIME)
		cpc	zh,r16
		;istTIME >= sollTIME ?-> shift !
		brsh	_G20symSFTb
		;-> time+1 & zurck 
		adiw	zh:zl,1
		sts		GsftTIl,zl
		sts		GsftTIh,zh
		jmp		_GsymBK	;...zurck
		;OK - endlos shift
		;== alten symbolbereich lschen
	_G20symSFTb:
		;timer=0
		clr	r16
		sts		GsftTIl,r16
		sts		GsftTIh,r16
	
		;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		;erste spalte des symbolbereiches lschen 
		;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
		clr	r2
		clr	r3
		clr	r4
		clr	r5
		clr	r6
		clr	r7
		clr	r8
		clr	r9
		;zuerst shift-register ins sram
		;shiftregister startadresse
		ldi	zh,high(SFTregST)
		ldi	zl,low(SFTregST)
		st	z+,r2
		st	z+,r3
		st	z+,r4
		st	z+,r5
		st	z+,r6
		st	z+,r7
		st	z+,r8
		st	z,r9	
		;.........................................
	;
		lds	r16,SYMhlp
		sts	xPOSabs,r16
		;graph. funktion
		clr	r16
		;sbr	r16,1<<graphBOXcont
		sbr	r16,1<<graphBOXfull
		;sbr	r16,1<<graphBOXclr
		;sbr	r16,1<<graphBOXinv
		sts	graphBOXflTE,r16
		call	_DRWcolSUB	;darstellen
		;danach xpos+1 !
		lds	r16,xPOSabs
		sts	SYMhlp,r16
		;symbol an xpos neu aufbauen
		lds	zl,symZpointLte	;temp. pointer laden
		lds	zh,symZpointHte
		sts	symZpointH,zh	;und als startadresse speichern !
		sts	symZpointL,zl
		jmp	_DRWsymBB




	;
	;.................................
	;spalte aus tabelle holen...
	;& in's Shiftregister...
	;.................................
_DRWsymB:
	lds	r16,xPOSabs	;aktuelle xPOS (zeigt auf neuen bereich)laden 
	sts	SYMhlp,r16	;temporr f. shift speichern !
	;

_DRWsymBB:
	lds	zh,symZpointH
	lds	zl,symZpointL
	lpm	r2,z+
	lpm	r3,z+
	lpm	r4,z+
	lpm	r5,z+
	sts	symZpointL,zl
	sts	symZpointH,zh
;	shift register inhalt, falls
;   	erforderlich verschieben
	lds	r16,SFTfactor	;shift-factor 0-7 laden
_DRWsymLOOP:
	tst	r16
	breq	_DRWsymXX
	clt
	dec	r16
	call	_SFTregA		;x*schieben
	jmp	_DRWsymLOOP
	;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_DRWsymXX:
	;zuerst shift-register ins sram
	;shiftregister startadresse
	ldi	zh,high(SFTregST)
	ldi	zl,low(SFTregST)
	st	z+,r2
	st	z+,r3
	st	z+,r4
	st	z+,r5
	st	z+,r6
	st	z+,r7
	st	z+,r8
	st	z,r9	
	;.........................................
	;graph. funktion
	clr	r16
	;sbr	r16,1<<graphBOXcont
	sbr	r16,1<<graphBOXfull
	;sbr	r16,1<<graphBOXclr
	;sbr	r16,1<<graphBOXinv
	sts	graphBOXflTE,r16
	call	_DRWcolSUB	;darstellen
	;.........................................
	;symbol komplett?
	lds	r16,SYMxSIZE
	cpi	r16,xSYM	;>=35 (0...35)
	brlo	_DRWspalteNEXT	
	;flags lschen..
	;wenn kein shift folgt !
	lds		r16,GsymFL
	sbrc	r16,sftSYM
	rjmp	_DRWsftNXT	;beim nchsten mal shiften
	clr		r16
	sts	GsymFL,r16
	jmp	_GsymBK		;-> symbol fertig	(vielleicht beim nchsten mal shiften?)
_DRWsftNXT:
	cbr	r16,1<<newSYM
	sts	GsymFL,r16
	jmp	_GsymBK			;-> symbol fertig - beim nchsten mal shiften!
	;
_DRWspalteNEXT:
	inc	r16
	sts	SYMxSIZE,r16
	jmp	_DRWsymBB	;-> symbol nicht fertig - nchste spalte darstellen...




;....................................................
_GsymBK:
	ret
