;-------------------------------------------------------------------
;modified Gcursor.asm for panasonic encoder // phase shifted signal
;-------------------------------------------------------------------
;
;
;
;signal A:  ______		__________
;		      |          |          |
;		  	|__________|          |___________
;
;signal B:  ___________		     _________
;			     |	    |
;                      |__________|
;
;--------------------------------------------------------------------
;konstanten:
;
;sigABK	=	last state signal A
;sigBBK	=	last state signal B
;SigA		=	new state signal  A
;SigB		=	new state signal  B
;--------------------------------------------------------------------
Encoder_Pan:
	lds	xl,curMODflTE	;load flag-var	



	;---------------------------------------
	;check signal A
	sbis	pinc,SigA
	rjmp	SigAchk		;signal A=low
	;---------------------------------------
	;A)signal A=high
	;& check last state !
	sbrs	xl,sigABK		;edge ?
	rjmp	sigALHedge		;l/h edge on signal A
	rjmp	SigBcheck		;signal A stable(high)
	;---------------------------------------
SigAchk:
	;B)signal A=low
	;& check last state !
	sbrc	xl,sigABK		;edge ?
	rjmp	sigAHLedge		;h/l edge on signal A
	rjmp	SigBcheck		;signal A stable(low)



			;---------------------------------------------
		sigALHedge:
			;Ax) low/high edge 
			;only action on stable signal B
			sbr	xl,1<<sigABK
			sbrs	xl,sigBstable
			rjmp	SigBcheck	
			;rjmp	goBACKenc		;not stable == back
			;check stable signal B state
			sbrs	xl,sigBBK
			rjmp	rotateRIGHT	;A=l/h edge B=stable low
			rjmp	rotateLEFT	;A=l/h edge B=stable high


			;---------------------------------------------
		sigAHLedge:
			;Bx) high/low edge 
			;only action on stable signal B
			cbr	xl,1<<sigABK
			sbrs	xl,sigBstable
			rjmp	SigBcheck	
			;rjmp	goBACKenc		;not stable == back
			;check stable signal B state
			sbrc	xl,sigBBK
			rjmp	rotateRIGHT	;A=h/l edge B=stable high
			rjmp	rotateLEFT	;A=h/l edge B=stable low







	;---------------------------------------
SigBcheck:
	;C)check signal B when signal A is stable
	sbis	pinc,SigB
	rjmp	SigBlow		;signal B low
	sbrs	xl,sigBBK		;edge ?
	rjmp	SigBLHedge		;l/h edge on signal B
	;signal stable
	sbr	xl,1<<sigBstable
	rjmp	goBACKenc

SigBLHedge:
	;signal unstable
	sbr	xl,1<<sigBBK	;state high
	cbr	xl,1<<sigBstable
	rjmp	goBACKenc

	;---------------------------------------
SigBlow:
	;D)signal B=low
	;& check last state !
	sbrc	xl,sigBBK		;edge ?
	rjmp	SigBHLedge		;h/l edge on signal B
	;signal stable
	sbr	xl,1<<sigBstable
	rjmp	goBACKenc

SigBHLedge:
	;signal unstable
	cbr	xl,1<<sigBBK	;state low
	cbr	xl,1<<sigBstable
	rjmp	goBACKenc



;--------------------------------------------------
;back jump without cursor action
;--------------------------------------------------
goBACKenc:
	sts	curMODflTE,xl
	jmp	_graphCURSORindex


;--------------------------------------------------
;turn right
;--------------------------------------------------
rotateRIGHT:
	sts	curMODflTE,xl
	;backlight flag setzen
	lds	r16,DIMflag
	sbr	r16,1<<BLnorm
	sts	DIMflag,r16
	jmp	_DturnUPbx


;--------------------------------------------------
;turn left
;--------------------------------------------------
rotateLEFT:
	sts	curMODflTE,xl
	;backlight flag setzen
	lds	r16,DIMflag
	sbr	r16,1<<BLnorm
	sts	DIMflag,r16
	jmp	_DturnDWbx
