

;--------------------------------------------------------------------------------------------
;-----------------------------------RC5 Automaten include file  -----------------------------
;--------------------------------------------------------------------------------------------
;----------Zyklische Abarbeitung durch 222s interrupt Aufruf -------------------------------
;--------------------------------------------------------------------------------------------
;--------------------------------------------------------------------------------------------

;--------------------------------------------------------------------------------------------------------------------
;_rc5freeRUN - matrix  *ACHTUNG* -> um die tasten einer fb frei definierbar zu gestalten
;				    mu bei der zuweisung dennoch eine feste reihenfolge
;				    eingehalten werden:

;_____________________________________________________________________
;funktion:                             |     prozesscounter/semicode:
;______________________________________|______________________________
;    <0>			       |       0
;    ...                               |       ...
;    <9>                               |       9
;    <programmierung (de-,)aktivieren> |       10
;    <programmaufruf>                  |       11
;    <manuelle eingabe/manipulation>   |       12
;    <global timer (de-,aktivierung>   |       13
;    <powerrail>an/aus                 |       14
;    <parameter +>                     |       15
;    <parameter ->                     |       16
;    <deaktivierung>                   |       17
;    <aktivierung>                     |       18
;    <kategorie deaktivieren>          |       19
;    <kategorie aktivieren>            |       20
;    <enter>                           |       21
;    <stop>                            |       22
;    <power/standby>		       |       23
;    ...			       |       ...
;    nicht definiert...		       |       42
;______________________________________|______________________________
;** virtual keycodes **		       |
;				       |
;    <value/parameter +>               |       15
;    <value/parameter ->               |       16
;    <powerrail>                       |       14
;    <programmaufruf>                  |       11
;    <manuelle eingabe>		       |       12
;    <enter>                           |       21
                   
		              


comSTATE:
	;status-register auf den stack
	push	r0
	push	r5
	push	r16
	push	r17
	push	r18
	push	r19
	push	r20
	push	r21
	push	r22
	push	yl
	push	yh
	push	zl
	push	zh

	in	r5,sreg	

	

	;timer 2 reload !
	ldi	r16,tiREL	;reload timer2 --> nach jedem overload folgt ein reload !!
	out	tcnt2,r16


	;test
	;toggle pind6
	sbic	portd,pind6
	rjmp	togpind6
	sbi		portd,pind6
	rjmp	_rc5decGO
togpind6:
	cbi		portd,pind6
	;test end



_rc5decGO:
	;lokale registerdefinition
	lds		r17,rc5decFL	;decFLAG
	lds		r18,rc5state	;rc5state
	lds		r19,rc5bistate	;biSTEP
	lds		r16,rc5adressTE
	lds		r22,rc5dataTE		;datenkopie holen
	lds		yl,rc5freeCNT		;freecoder process counter
	;----------------------------------------
	;taste gedrckt == learnmode abbrechen !
	sbis	pind,pind3		 	
	rjmp	_rc5breakEX	;wieder gedrckt ende !
	;----------------------------------------

	rcall	_takeNXT	;taste ir-pin ab !!!
	
	;Weise Automatenzustand einem Ereignis zu
	cpi	r18,20	;warte auf startsequenz ??? (nach ruhe...)
	breq	_svGO		;yes...
	
	cpi	r18,33	;startsequenz erkannt ????
	breq	_stOK	

	cpi	r18,42	;nutzbit ,1' erkannt
	breq	_HIbitX
	
	cpi	r18,50	;nutzbit ,0' erkannt
	breq	_LObitX
	
	rjmp	_svGO
	
;-----------------------------
_LObitX:
	jmp	_LObit

_HIbitX:
	jmp	_HIbit

;----------------------------------------------------------------------------
;rcksprung aus interrupt-routine
;----------------------------------------------------------------------------
_stOK:
	clr	r19		;bitcounter 0
		
_svGO:
	;backup lokaler registerdefinitionen
	sts	rc5adressTE,r16
	sts	rc5dataTE,r22		;sichere daten-kopie nach 
	sts	rc5freeCNT,yl		;prozesscounter...
	sts	rc5decFL,r17		;decFLAG ---> ,compl' <=> high (nach Ausfhrung lschen !)
	sts	rc5state,r18		;rc5state---> decoder status   (intern relevant)
	sts	rc5bistate,r19		;biSTEP  ---> bit counter      (intern relevant)
	;Rcksprung aus Interrupt - Routine 
;	jmp	COMstateBK




	;
;----------------------------------------------------------------------------
;test integration panasonic encoder
;----------------------------------------------------------------------------

	lds	r16,curMODflTE	;load flag-var	
	;---------------------------------------
	;check signal A
	sbis	pinc,SigA
	rjmp	SigAchk		;signal A=low
	;---------------------------------------
	;A)signal A=high
	;& check last state !
	sbrs	r16,sigABK		;edge ?
	rjmp	sigALHedge		;l/h edge on signal A
	rjmp	SigBcheck		;signal A stable(high)
	;---------------------------------------
SigAchk:
	;B)signal A=low
	;& check last state !
	sbrc	r16,sigABK		;edge ?
	rjmp	sigAHLedge		;h/l edge on signal A
	rjmp	SigBcheck		;signal A stable(low)



			;---------------------------------------------
		sigALHedge:
			;Ax) low/high edge 
			;only action on stable signal B
			sbr	r16,1<<sigABK
			sbrs	r16,sigBstable
			rjmp	SigBcheck	
			;rjmp	goBACKenc		;not stable == back
			;check stable signal B state
			sbrs	r16,sigBBK
			rjmp	rotateRIGHT	;A=l/h edge B=stable low
			rjmp	rotateLEFT	;A=l/h edge B=stable high


			;---------------------------------------------
		sigAHLedge:
			;Bx) high/low edge 
			;only action on stable signal B
			cbr	r16,1<<sigABK
			sbrs	r16,sigBstable
			rjmp	SigBcheck	
			;rjmp	goBACKenc		;not stable == back
			;check stable signal B state
			sbrc	r16,sigBBK
			rjmp	rotateRIGHT	;A=h/l edge B=stable high
			rjmp	rotateLEFT	;A=h/l edge B=stable low







	;---------------------------------------
SigBcheck:
	;C)check signal B when signal A is stable
	sbis	pinc,SigB
	rjmp	SigBlow		;signal B low
	sbrs	r16,sigBBK		;edge ?
	rjmp	SigBLHedge		;l/h edge on signal B
	;signal stable
	sbr	r16,1<<sigBstable
	rjmp	goBACKenc

SigBLHedge:
	;signal unstable
	sbr	r16,1<<sigBBK	;state high
	cbr	r16,1<<sigBstable
	rjmp	goBACKenc

	;---------------------------------------
SigBlow:
	;D)signal B=low
	;& check last state !
	sbrc	r16,sigBBK		;edge ?
	rjmp	SigBHLedge		;h/l edge on signal B
	;signal stable
	sbr	r16,1<<sigBstable
	rjmp	goBACKenc

SigBHLedge:
	;signal unstable
	cbr	r16,1<<sigBBK	;state low
	cbr	r16,1<<sigBstable
	rjmp	goBACKenc



;--------------------------------------------------
;back jump without cursor action
;--------------------------------------------------
goBACKenc:
	sts	curMODflTE,r16
	rjmp	COMstateBK


;--------------------------------------------------
;count turn right
;--------------------------------------------------
rotateRIGHT:
	sts	curMODflTE,r16
	clr	r16
	sts	countLEFT,r16
	lds	r16,countRIGHT
	inc	r16
	sts	countRIGHT,r16
	rjmp	COMstateBK


;--------------------------------------------------
;count turn left
;--------------------------------------------------
rotateLEFT:
	sts	curMODflTE,r16
	clr	r16
	sts	countRIGHT,r16
	lds	r16,countLEFT
	inc	r16
	sts	countLEFT,r16


COMstateBK:
	out	sreg,r5
	pop	zh
	pop	zl
	pop	yh
	pop	yl
	pop	r22
	pop	r21
	pop	r20
	pop	r19
	pop	r18
	pop	r17
	pop	r16
	pop	r5
	pop	r0


	reti



;---------------------------------------------------------------------------
;decodiere nutzbits 1/0 und bilde adress-/data frame
;---------------------------------------------------------------------------
_HIbit:
	inc	r19
	set	
	rjmp	A_CObit
_LObit:	
	inc	r19
	clt

;----> bit count=1
A_CObit:
	cpi	r19,1
	brne	B_CObit
	brtc	toLO
	sbr	r17,1<<toggle		;t-flag <=> toggle bit !
	;
	rjmp	_svGO			;und tsch
toLO:
	cbr	r17,1<<toggle		
	;
	rjmp	_svGO
	
	
;-----> bit count = 2-6 (adresse)
B_CObit:
	cpi	r19,7
	brlo	C_CObit
	
	cpi	r19,7
	brsh	D_CObit
	 	
	rjmp	_svGO

C_CObit:
	rol	r16			;
	bld	r16,0			;copy t-flag -> bit0
	rjmp	_svGO

;-----> bit count	= 7-12 (daten)
D_CObit:
	rol	r22
	bld	r22,0			;copy t-flag -> bit0
	
	cpi	r19,12
	brsh	_svGOA
	rjmp	_svGO	
;---------------------------------------------------------------------
	;komplett!!!!!!!!!
_svGOA:	
	cbr	r22,1<<6			;daten max. 6bit
	cbr	r22,1<<7
	;
	clr	r18			;prozecounter 0
	clr	r19			;bit counter 0
	;
	sbrc	r17,learnX
	rjmp	_rc5LEARN		;lernmodus aktiv !


	;dauerhafte tastenbettigung wird 
	;nicht akzepziert = toggle alt /neu prfen!
	sbrs	r17,toggle		;toggle aktuell ?
	rjmp	_svGOAb			;toggle aktuell=0
	;toggle aktuell=1
	sbrc	r17,toggleBK	;& toggle alt   ?
	rjmp	_rc5dataTKX		;toggle alt = toggle neu <=> nicht ok!
	sbr		r17,1<<toggleBK	;nun toggle neu nach alt...
	rjmp	_svGOAc			;und decodieren
	;toggle aktuell=0	
_svGOAb:	
	sbrs	r17,toggleBK	;& toggle alt   ?
	rjmp	_rc5dataTKX		;toggle alt = toggle neu <=> nicht ok!
	cbr		r17,1<<toggleBK	;nun toggle neu nach alt...
_svGOAc:
	;rep.counters preset
	ldi	yl,rc5repB
	sts	rc5codeREPa,yl		;repeatcounters

	;
_svGOAd:
	;und decodieren
	rcall	_REDe2			;kein lernmodus aktiv == konvertierung lt. tabelle

	;----------------------------------------
	;flag in app lschen 
	sbr	r17,1<<compl		;transfer complete !!
	;realdaten sichern
	sts	rc5adress,r16		;rc5 adresse
	sts	rc5data	,r22		;rc5 daten
_rc5dataTK:
	clr	yl
	rjmp	_svGO

	;repeat check
_rc5dataTKX:
	;counters checken zl/zh
	lds	yl,rc5codeREPa
	tst	yl
	breq	_svGOAdX
	dec	yl
	sts	rc5codeREPa,yl		;repeatcounters
	rjmp	_rc5dataTK
	;
_svGOAdX:
	;rep.counters preset
	ldi	yl,rc5repA
	sts	rc5codeREPa,yl		;repeatcounters
	rjmp	_svGOAd	

;--------------------------------------------------------------------------------------------------------
;-------------- lernmodus aktiv // ---------------------- -----------------------------------------------
;--------------------------------------------------------------------------------------------------------

_rc5LEARN:
	;#code-wiederholsperre
	lds		yh,rc5datPRbk		;alte datenkopie holen nochmals
	cp		r22,yh				;vergleiche letzte mit aktueller kopie
	brne	OKfreeto				
	rjmp	_rc5freeEXY			;bedeutet selbe taste noch immer gedrckt <=> wird nur einmal akzeptiert !!!
OKfreeto:	
	sts	rc5datPRbk,r22			;sichere daten-kopie nach 0x9d
	rjmp	_rc5freeRUN			;und weiter decodieren !
	
;--------------------------------------------------------------------------------------------------------------------
_rc5freeRUN:
	mov	zl,r22				;adressiere e2prom (0x30 + real rc5-code(r22))
	cpi	zl,0x5b				;entspricht rc5 code 0-89
	brsh	_rc5freeEXY		;wert >= 0x5b ==nicht erlaubt ---> zurck ohne abspeichern
_WRITe2:
	sbic	eecr,eewe		; EEWE nicht gelscht ?
	rjmp	_WRITe2	           	; warte...
	clr	zh
	out	eearh,zh		;whle e2-speicherbereich ab 0x4a
	out	eearl,zl		; adressierung e2prom
	out	eedr,yl                ; kopiere ins'e2prom-datenregister 
	sbi	eecr,eemwe	
	sbi	eecr,eewe		;set EEPROM Write strobe
					; nach 4 maschinenzyklen ist der schreibprozess abgeschlossen

	inc	yl
;--------------------------------------------------------------------------------------------------------------------
	
_rc5freeEXY:
	cbr	r17,1<<compl	
	cpi	yl,0x5b			;max. 90 speicherpltze reserviert fr rc5 freecoder
	brlo	_rc5OKfreeEX
_rc5breakEX:
	clr	yl
	cbr	r17,1<<learnX	;lernprozess abgeschlossen
	ldi		zh,0xff
	sts	rc5datPRbk,zh
	rjmp	_svGO
	
_rc5OKfreeEX:
	rjmp	_svGO
	




	



;------------------------------------------------------------------------------------------------------
;------------------- lese  daten aus e2prom (adresse r22 -> daten r22) ----------------------------------
;------------------------------------------------------------------------------------------------------	
_REDe2:
	cpi	r22,0x5b		;werte >=0x5b werden nicht akzeptiert
	brsh	_REDe2D
	rjmp	_REDe2X
_REDe2D:
	ldi	r22,0x5a		;bei werten >=0x5b wird automatisch 0x5a(grter wert) gesetzt
_REDe2X:
	sbic	eecr,eewe		; EEWE nicht gelscht ?
	rjmp	_REDe2X			; warte...
	clr	r21
	out	eearh,r21		;adressiere e2prom 	
	out	eearl,r22		; adressierung e2prom
	sbi	eecr,eere		; bereite bertragung aus e2prom vor 
	in	r22,eedr		; kopiere daten aus e2prom nach r22
	ret


;--------------------------------------------------------------------------------------
;auto decoder
;--------------------------------------------------------------------------------------


_takeNXT: 
	clr	r20
	sbis	pind,pind7
	rjmp	_setcarry
	clc	;select lsb
_state:	
	rol	r18
	ldi	zl,low (_tbREMOTE *2)
	ldi	zh,high(_tbREMOTE *2)
	add	zl,r18
	adc	zh,r20
	lpm	r18,z		;tabelleninhalt (byte n --> r0) 
	ret
_setcarry:	
	sec	;select msb
	rjmp	_state


