;******************************************************************
;graphical display driver & font-table (5*8dots)
;******************************************************************
.include "m32def.inc"
;.equ	FLASHSHIFT			=	0x88b8		;start-speicheradresse im system FLASH
;
;hard-wire:						
;pa0...pa7 	== data0...7
;
;pc7  	== cs1 
;pc6		== cs2
;pc5		== w/r
;pb3		== oc0 (pwm kontrast)
;pd5		== oc1a(pwm helligkeit)
;pc4		== d/i
;pc3		== e
;pc2		== up/dreh
;pc1		== dw/dreh
;pc0		== push/dreh
;pd7		== rc5_fb
;pd3		== prog key

.equ	SigB		= 	2	;panasonic enc
.equ	Dup		=	2	;old enc.
.equ	SigA		= 	1	;panasonic enc
.equ	Ddw		=	1	;old enc.
.equ	Dpush		= 	0
;display-flags:
.equ	Dbusy		=	7	;pa7	;busy-flag		;-
.equ	Don		=	5	;pa5	;on-flag		;-
.equ	Dres		=	4	;pa4	;reset-flag		;-
;
.equ	Dena		=	3	;pc3	
.equ	Did		=	4	;pc4
.equ	Dwr		=	5	;pc5
.equ	cs1		=	7	;pc7
.equ	cs2		=	6	;pc6


;****************************************************************
;definitionen
;****************************************************************
;
;
.equ	graphFU		=	0x440	;graphische funktionsvariable
.equ	graphFUte		=	0x441	;temp. graph. variable
.equ	GsymFL		=	0x442	;gsym steuerflag
.equ	GsymTIAl		=   	0x443	;lower byte dyn.timerA
.equ	GsymTIAh		=	0x444	;higher byte dyn.timerA
.equ	GsymTIBl		=   	0x445	;lower byte dyn.timerB
.equ	GsymTIBh		=	0x446	;higher byte dyn.timerB
.equ	GsftTIl		=	0x447	;lower byte shift timer
.equ	GsftTIh		=	0x448	;higher byte shift timer
.equ	Xshift		=	0x449	;shift faktor (xpos+xshift)=aktuelle pos
.equ	SYMxSIZE		=	0x44a	;real xsize variable
.equ	SYMyBYTE		=	0x44b	;real ybyte variable
.equ	SYMhlp		=	0x44c
.equ	symZpointL		=	0x44d
.equ	symZpointH		=	0x44e
.equ	symZpointLte	=	0x44f
.equ	symZpointHte	=	0x450


;backlight
.equ	NORMlight	=	0x451	;normal helligkeit
.equ	DIMlight	=	0x452	;dim helligkeit
.equ	DIMcntaL	=	0x453	;dimm counter 1 low
.equ	DIMcntaH	=	0x454	;               high
.equ	DIMcntbL	=	0x455	;dimm counter 2 low
.equ	DIMcntbH	=	0x456	;               high
.equ	DIMflag	=	0x457	;dimm flags

;flags
.equ	BLred		=	0		;reduziere backlight
.equ	BLnorm	=	1		;normaler backlight wert

;rc5 decoder
.equ	rc5decFL	=	0x45a	;decFLAG
.equ	rc5state	=	0x45b	;rc5state
.equ	rc5bistate	=	0x45c	;biSTEP
.equ	rc5adress	=	0x45d	;rc5 adresse
.equ	rc5data	=	0x45e	;rc5 daten	
.equ	rc5dataTE	=	0x45f	;temp.rc5 daten
.equ	rc5freeCNT	=	0x460	;freecoder counter




;boot counter;.......................................................
.equ	bootACNTl	=	0x461	;boot Acnt L
.equ	bootACNTh	=	0x462   ;boot Acnt H
.equ	bootBCNTl	=	0x463	;boot Bcnt L
.equ	bootBCNTh	=	0x464   ;boot Bcnt H
;rc5
.equ	rc5adressTE	=	0x465	;adressbk
.equ	rc5datPRbk	=	0x466
.equ	rc5codeREPa	=	0x467	;repeatcounters

;encoder 
.equ	countRIGHT	=	0x468
.equ	countLEFT	=	0x469


;konstanten
.equ	rc5repA		=	0x1 	;.3rep
.equ	rc5repB		=	0xd 	;2sec


;rc5 flags
.equ	toggle		=	0
.equ	compl			=	1
.equ	learnX		=	2
.equ	toggleBK		=	3


;.....................................................
;flags (GsymFL)
.equ	showSYM	  	=	0	;symbol darstellen (aus sysIF)
.equ	dynSYM		=	1   ;dynamische symboldarstellung
.equ	sftSYM		=	2	;symbol verschieben
.equ	newSYM		=	3	;neues symbol darstellen
;.....................................................
;konstanten
.equ	ySYM		=	4	;4 bytes pro spalte
.equ	xSYM		=	35	;36 spalten (0...35)
.equ	sftTIME	=	40000
.equ	dynaTIME	=	4500
.equ	dynbTIME	= 	1000
.equ	symLARGE	=	144
;
.equ	bootCT		=	65535
.equ	bootEND		=	30	


;konstanten
.equ	DcntA		=	65534
.equ	DcntB		=	16	;	1690
;info: produkt DnctA*DcntB= 110754150 zyklen (runtime ca.10sekunden)



.equ	tempAUSmain	=	0x7e	;temp.auswahl
.equ	tempAUSsub	=	0x7f	;temp.auswahl
;variablen:
.equ	TXTpointL	=	0x80		;txt-adresspointer LOW
.equ	TXTpointH	=	0x81		;txt-adresspointer HIGH
.equ	CHARte	=	0x82		;temporrer character

;temporre positionsvariablen f. graphische elemente
.equ	curMODflTE		=	0x88	;cursor flagvariable
.equ	graphBOXflTE	=	0xb2	;graphic flagvariable
;
.equ	graphBOXposXte	=	0x89
.equ	graphBOXposYte	=	0x8a
.equ	graphBOXsizXte	=	0x8b
.equ	graphBOXsizYte	=	0x8c




.equ	xPOSabs		=	0x90		;absolute x-position
.equ	yPOSabs		=	0x91		;absolute y-position
.equ	xPAGEpos	=	0x92		;x-page position
.equ	xCHARsiz	=	0x93		;char x-size
.equ	yCHARsiz	=	0x94		;char y-size
;
.equ	stZpointL	=	0x95		;z-pointer l
.equ	stZpointH	=	0x96		;z-pointer h
.equ	stYpointL	=	0x97		;y-pointer l
.equ	stYpointH	=	0x98		;y-pointer h
;	
.equ	CNTx		=	0x99		;x-pixel counter
.equ	CNTy		=	0x9a		;y-pixel counter	
.equ	radCIRCLE	=	0xb3		;radius circle
.equ	xPLOT		=	0xb4		;x-punkt
.equ	yPLOT		=	0xb5		;y-punkt
.equ	radCNT	=	0xb6		;winkelberechnungsvariable
.equ	lgtLINE     = 	0xb9		;relative linienlnge
.equ	alphaLINE   = 	0xba		;linienwinkel (30' schritte)
.equ	quadLINEfl  = 	0xbb		;flagvariable (plotquadrant)
.equ	lgtLINEte	=	0xbc		;temp.relative linienlnge
;
.equ	paraA		=	0xbd		;parameter A (bargraph...)
.equ	paraB		=	0xbe		;parameter B	
.equ	paraC		=	0xbf		;parameter C
.equ	paraD		=	0xc0		;parameter D
.equ	paraE		=	0xc1		;parameter E
.equ	paraF		=	0xc2		;parameter F
.equ	paraG		=	0xc3		;parameter G
.equ	paraH		=	0xc4		;parameter H
;
;temporre text-,u. Cursorvariablen 
.equ	maxINDEX	=	0xca		;max. anzahl von indexmarken innerhalb eines auswahlfeldes
.equ	upperINDEX	=	0xcb		;DISPLAY-an oberster/erster stelle gewnschte indexmarke
.equ	lastINDEX	=	0xcc		;DISPLAY-an unterster/letzter stelle stehende indexmarke
.equ	scrollDIR	=	0xcd		;anzeigerichtung vertikal/horizontal
.equ	TXTstartL	=	0xce		;text startadresse Low-byte
.equ	TXTstartH	=	0xcf		;text startadresse High-byte
.equ	CHARcntTE	=	0xd0		;temporrer character-counter
.equ	downINDEX	=	0xd1		;temporre indexmarke
.equ	INDEXpointL	=	0xd2		;dynamischer index-adresspointer Low-byte
.equ	INDEXpointH	=	0xd3		; "                         "    High-byte
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.equ	comBUFadrL	=	0xd4		;buffer adresse L
.equ	comBUFadrH	= 	0xd5		;buffer adresse H
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.equ	comFLAG	=	0xd6		;kommunikation flag-variable
;-> flags (comFLAG)
.equ	newBUFdata	=	0		;new data in buffer - flag
.equ	spiBUSY	=	1		;datenbertragung aktiv
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.equ	paraFUNC	=	0xd7		;parameter funktions-flagvariable	
;-> flags (graphFUNC)
.equ	numG		=	5		;numerische darstellung
.equ	parG 		=	6		;parameter
.equ	barG 		=	4		;bargraph
.equ	ediG 		=	7		;parameter editieren
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.equ	cntPAR	=	0xd8		;anzahl der bertragenen parameter
.equ	cntPARte	=	0xd9		;"                "
.equ	tePAR		=	0xda		;temp. parameter
.equ	tePARx	=	0xdb		;"        "
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.equ	TURNcnt	=	0xdc		;drehratenwert 
.equ	CURindex	=	0xdd		;cursor index
.equ	turnDWnew	=	0xde		;
.equ	turnDWold	=	0xdf		;
.equ	curBOXaktX	=	0xe0		;aktuelle cursor koordinaten
.equ	curBOXaktY	=	0xe1		;"
.equ	curSIZaktX	=	0xe2		;"
.equ	curSIZaktY	=	0xe3		;"
.equ	curLINEakt	=	0xe4		;"
;
.equ	paraMIN	=	0xe5
.equ	paraMAX	=	0xe6
.equ	paraPOS	=	0xe7
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;spi
.equ	spiDATctIST		=	0xe8
.equ	spiDATctSOLL	=	0xe9
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;temp. hilfsvariablen
.equ	helpA			=	0xea





.equ	SFTregST		=	0xaa	;startadresse 56-bit schieberegister
						;->0xb1
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;index-buffer 0xfa - 0x1f4
.equ	bufINDEX	=	0xfa		;indexbuffer startadresse
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;text/parameter buffer 0x1f5 - 0x385
.equ	patxBUF	=	0x1f5		;parameter / text startadresse
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;kommunikation if-buffer 0x386 - 0x3cc
.equ	comBUF	=	0x386		;kommunikation if-buffer startadresse
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;aktiv-parameter-buffer 0x3cd - 0x42e
.equ	paraACT	=	0x3cd		;aktive parameter (max. 15 parameter inkl.min/max)
;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;neue variablen fr flexible
;fontdarstellung & positionierung

;a) page-berechnung (basis: txtBOXpos0y + yCHARsize) 
.equ	firstPAGEmask	=	0x9b	;erste page mask innerhalb des bereichs
.equ  lastPAGEmask	=	0x9c	;letzte page mask innerhalb des bereichs
.equ	cntPAGE		=	0x9d	;page counter
.equ	firstPAGE		=	0x9e	;(#)first page
.equ	lastPAGE		=	0x9f	;(#)last page
.equ	effPAGErange	=	0xa0	;(#)effective page-range 1-8
.equ	SFTfactor		=	0xa1	;(#)shift factor
.equ	CHARfactorX		=	0xb7	;(#)X-char vergrerungsfaktor
.equ	CHARfactorXte	=	0xb8	;(#)X-char vergr. temp
.equ	CHARfactorY		=	0xa2	;(#)Y-char vergrerungsfaktor
.equ	LINEth		=	0xa3	;(#)linienstrke graph-mode
;


;*******************************************************************************
;****************************************************************

;flags zu <quadLINEfl>:
.equ	PxMy	     = 	0	;quadrant rechts oben (+x,-y)
.equ	PxPy	     = 	1	;quadrant rechts unten(+x,+y)
.equ	MxPy	     = 	2	;quadrant links unten (-x,+y)
.equ	MxMy	     = 	3	;quadrant links oben  (-x,-y)
;
;flags <graphBOXflTE>:
;
.equ	graphBOXfull	=	0	;graph-box full (0=ergnzen / 1= berschreiben)
.equ	graphBOXready	=	1	;graph-box ready
;.equ	graphBOXcursor	=	2	;graph-box menu-cursor aktiv
.equ	graphBOXpara	=	3	;graph-box parameter darstellung (aus sram)
.equ	graphBOXclr		=	4	;graph-box rahmen clear
.equ	graphBOXbar		=	5	;graph-box bargraph
.equ	graphBOXcont	=	6	;graph-box contour (rahmen)
.equ	graphBOXinv		=	7	;graph-box invertieren

;***************************************************************
;flags <curMODflTE>:
;
.equ	curEDIT		=	0	;edit mode aktiv
.equ	SigABK		=	1	;letzter drehratenstatus sigA
.equ	SigBBK		=	2	; "                      sigB
.equ	curINIT		=	3	;cursor initialisiert		
.equ	BOXcursor		=	4	;menu-cursor enabled
.equ	BOXactiv		=	5	;cursor aktiv
.equ	puHIGH		=	6	;letzter push status
.equ	sigBstable		=	7	;aktueller encoder status

;
;mask:
;ACHTUNG: nach adressierung ein dummy-read erforderlich !
;a) write instructions
;- D/I = 0 
;- W/R = 0
;
.equ	IdisON	=	0x3f	;instruktion display ON
.equ	IdisOFF	=	0x3e	;instruktion display OFF
.equ	IpageADR	=	0xb8	;instruktion set x-page adress 0 (add 1-7 for following pages!)
.equ	IyADR		=	0x40	;instruktion set y-line adress 0 (add 1-63 for following lines!)
.equ	IstLINE	=	0xc0	;instruktion set display start-line 0 (add 1-63 for following lines!
.equ	IleftYpage	=	0x40	;d/i,w/r,cs1,cs2 mask for left y-page	
.equ	IrightYpage =	0x80	; "          "        "   right y-page
;
;b) write data
;- D/I =1
;- W/R =0
;
;c) read instructions
;- D/I =0 
;- W/R =1
;
;d) read data
;- D/I =1
;- W/R =1
;
;*************************************************************
;
;*************************************************************
;system-basics:
.equ	displayPAGEmax	=	8	;page 0-7 (8pages*8dots=64)
.equ	displayCOLmax	=	128	;spalte 0-127 	
.equ	displayLINEmax	=	displayPAGEmax * 8
;*************************************************************************************	
;system init
;*************************************************************************************
.cseg
.org 	0
	jmp	_initSYS	;nach auftstarten...

; Overflow2 Interrupt Vector Address
.org	0x0a		;timer2 ov-interrupt 222s !
	jmp	comSTATE
;
;SPI-interrupt 0x18
.org	0x18
	jmp	_SPIslave	



;.....................................................................................
;...liegt auerhalb der int-vektoren
.org	0x2b
	;system init
_initSYS:
	;stack-range
	ldi	r16,high(ramend)
	out	sph,r16
	ldi	r16,low(ramend)
	out	spl,r16

	;+++++++++++++++++++++++++++++++++++++++++++
	;disable jtag IF
	in	r16,mcucsr
	sbr	r16,1<<jtd
	out	mcucsr,r16
	nop
	out	mcucsr,r16
	;+++++++++++++++++++++++++++++++++++++++++++
	;porta-setting (displaydata new)
	ldi	r16,0
	out	ddra,r16	;data 0-7 (default=input)
	out	porta,r16
	;+++++++++++++++++++++++++++++++++++++++++++

	;portb-setting 
	ldi	r16,0x8
	out	ddrb,r16
	clr	r16	
	out	portb,r16

	;+++++++++++++++++++++++++++++++++++++++++++
	;portc-setting (display control & dreh)
	ldi	r16,0xf8	;0-2 input(dreh),3-7 output (control)
	out	ddrc,r16	
	ldi	r16,0x28	;e & w/r high
	out	portc,r16
	;+++++++++++++++++++++++++++++++++++++++++++

	;portd-setting
	ldi	r16,0x60	;x20
	out	ddrd,r16
	ldi	r16,0x80		;
	out	portd,r16
	;
	;

	;timer2 overflow-interrupt alle 220s
	;Fck(11059200Mhz)/8= 1382400Hz/154=8976Hz <=> 1/8976Hz = 111,4s
	;Fclk(11059200MHz)/64=172800Hz/38=4547,4Hz <=> 1/4547,4Hz = 220s
	;
.equ	tiREL	=	219
	;tiREL=(256+1)-38 = 219
	clr	r16
	sbr	r16,1<<toie2	;enable overflow interrupt
	out	timsk,r16
	clr	r16
	sbr	r16,1<<cs22
	out	tccr2,r16		;prescale /64
	
	ldi	r16,tiREL		;s reload 
	out	tcnt2,r16
	;
	;
	;
	;pwm defaults
	;a) timer0 (8bit)
	;tccr0
	;wgm00=1 & wgm01 =1 ;fast pwm
	;com00=0 & com01 =1 ;clear oc0 on compare match / set on top
	;cs00 =0 & cs01  =1 & cs02 =0 ;flck/8
	;tcnt0=0
	;ocr0 =0-255 (pulsw.)
	;
	;
	clr	r16
	ldi	r16,0b01101001	;0
	out	tccr0,r16
	ldi	r16,0
	out	tcnt0,r16
	ldi	r16,70	;pwm pulsweite  20=-3,5V|35 =-3,7V|45 =-3,8V|50=-3,8V|100=-3.5V|150=-3,2V|200=-2,7V
				;              220=-2,4V|235=-2,3V|245=-1,9V|250=-1V |253=+0,7V|254=+1V | /fclk:0
	out	ocr0,r16

	;
	;
	;b) timer1 (16bit)
	;tccr1a
	;wgm10=1 & wgm11=0 ;fast pwm 8-bit
	;com1a0=0 & com1a1=1 ;clear oc1a on compare match / set on top
	;com1b0=0 & com1b1=0 ;oc1b no timer function
	;tccr1b
	;wgm12=1 & wgm13=0 ;fast pwm 8-bit
	;cs10=0 & cs11=1 & cs12=0 ;flck/8
	;tcnt1h & tcnt1l =0
	;ocr1h & ocr1l= 0-255 (pulsw.)
	;
	clr	r16
	ldi	r16,0b10000001	
	out	tccr1a,r16	
	clr	r16
	ldi	r16,0b00001010	
	out	tccr1b,r16
	clr	r16
	out	tcnt1h,r16
	out	tcnt1l,r16
	out	ocr1ah,r16
	ldi	r16,220	;pwm pulsweite
	sts	NORMlight,r16
	out	ocr1al,r16
	;
	;dimmed backlight
	ldi	r16,50
	sts	DIMlight,r16
	;
	clr	r16
	sts	DIMflag,r16
	;
	clr	r16
	sts		DIMcntaL,r16
	sts		DIMcntaH,r16
	sts		DIMcntbL,r16
	sts		DIMcntbH,r16
	;
	;rep.counters preset
	ldi	zl,rc5repB
	sts	rc5codeREPa,zl		;repeatcounters

	clr	r16
	sts	rc5decFL,r16

	;encoder counter=0
	sts	countRIGHT,r16
	sts	countLEFT,r16


;******************************************************************************************
;startup
;******************************************************************************************
;display initialisieren
call		_initDIS	;display an / 

;...............................................................................
;variablen initialisieren 
;...............................................................................
clr	xl
sbr	xl,1<<newBUFdata	;bufferdaten vorhanden 
cbr	xl,1<<spiBUSY		;
sts	comFLAG,xl
;mit upperINDEX=0 starten
clr	xl
sts	upperINDEX,xl
;mir cursorINDEX=0 starten
clr	xl
sts	curINDEX,xl
;drehraten/cursor-flag =0 starten (wird im sysIF freigegeben)
clr	xl
cbr	xl,1<<BOXcursor ;cursorroutine disable
sts	curMODflTE,xl
;
clr	xl
sts	spiDATctIST,xl
;GsymFL=0
sts	GsymFL,xl
;...............................................................................


	;+++++++++++++++++++++++++++++++++++++++++++
	;++++++++ freecoder aktivieren ? +++++++++++
	;+++++++++++++++++++++++++++++++++++++++++++
	sbic	pind,pind3
	rjmp	_runSYSTEM
	;freecoder aktivieren !
	;<=> taste beim booten gedrckt
			;a) wait freecoder maske darstellen....
			ldi	zh,high(comBUF)
			ldi	zl,low(comBUF)
			;para-flags
			ldi	r16,0
			st	z+,r16	;para function (keine parameter - kein edit mode)
			;text59						;
			ldi	r16,22		;basistext 59
			st	z+,r16
			;
			ldi	r16,255	;KEIN auswahlmen (255)
			st	z+,r16
			;
			ldi	r16,255	;KEIN sub-auswahlmen (255)
			st	z+,r16
			;
			ldi	r16,2	;big text 2
			st	z+,r16
			;
			ldi	r16,251	;KEINE graphische funktion // big text (251)
			st	z+,r16
			;darstellen
			call	_sys01IF
	
			;b) taste >3 sekunden gedrckt == rc5freecoder enabled !
			clr	r16
			sts	bootACNTl,r16
			sts	bootACNTh,r16
			sts	bootBCNTl,r16
			sts	bootBCNTh,r16
			;counter laden...
			lds	zl,bootACNTl
			lds	zh,bootACNTh
			lds	yl,bootBCNTl
			lds	yh,bootBCNTh
	_glcdBOOTloopA:
			sbic	pind,pind3
			rjmp	_runSYSTEM
			;zuerst B counter prfen
			;>=500 == freecoder entry
			cpi	yl,low(bootEND)		;Compare low byte
			ldi	r16,high(bootEND)	;
			cpc	yh,r16				;Compare high byte
			brsh	_glcdFREECODER	;...FREECODER ENTRY !
			;jetzt A counter prfen
			;luft durch 0....65535
			adiw	zh:zl,1			;counter A +1
			cpi	zl,low(bootCT)		;Compare low byte
			ldi	r16,high(bootCT)	;
			cpc	zh,r16	
			brlo	_glcdBOOTloopA	;loop...
			;boot counter B+1
			adiw	yh:yl,1
			;clr  counter A
			clr		zh
			clr		zl
			rjmp	_glcdBOOTloopA	;loop...
			 

;...FREECODER ENTRY !
_glcdFREECODER:	
			;b) freecoder maske darstellen....
			ldi	zh,high(comBUF)
			ldi	zl,low(comBUF)
			;para-flags
			ldi	r16,0
			st	z+,r16	;para function (keine parameter - kein edit mode)
			;text60						;
			ldi	r16,60		;basistext 60
			st	z+,r16
			;
			ldi	r16,255	;KEIN auswahlmen (255)
			st	z+,r16
			;
			ldi	r16,255	;KEIN sub-auswahlmen (255)
			st	z+,r16
			;
			ldi	r16,3	;big text 3
			st	z+,r16
			;
			ldi	r16,251	;KEINE graphische funktion // big text (251)
			st	z+,r16

			;bertragung z.display freigeben
			clr	xl
			sbr	xl,1<<newBUFdata	;bufferdaten vorhanden 
			cbr	xl,1<<spiBUSY		;
			sts	comFLAG,xl
			;&
			;darstellen
			call	_sys01IF
			;------------------------------
			;nun taste loslassen...
			;bei wiederholter bettigung 
			;wirdas Ganze beendet !
_glcdFREECODERwt:
			sbis	pind,pind3		 	
			rjmp	_glcdFREECODERwt
			;-------------------------------
		
			;d)enable learnmode
			clr		r17
			sbr		r17,1<<learnX
			sts		rc5decFL,r17
			;e)clr prozess cnt
			clr		r17
			sts	rc5freeCNT,r17		;prozesscounter...
			ldi		r17,0xff
			sts	rc5datPRbk,r17
			;c) timer2 int enabled 
			ldi	r16,tiREL		;s reload 
			out	tcnt2,r16
			;f) enable global interupts
			sei
_glcdFREECODERloop:
			lds		r17,rc5decFL
			sbrc	r17,learnX					
			rjmp	_glcdFREECODERloop
			;bertragung z.display freigeben
			cli
			clr	xl
			sbr	xl,1<<newBUFdata	;bufferdaten vorhanden 
			cbr	xl,1<<spiBUSY		;
			sts	comFLAG,xl
			;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
									_runSYSTEM:			
									;startdisplay
									;-> daten in spi buffer							
									ldi	zh,high(comBUF)
									ldi	zl,low(comBUF)
									;para-flags
									ldi	r16,0
									st	z+,r16	;para function (keine parameter - kein edit mode)
									;text1						;
									ldi	r16,0		;basistext 0
									st	z+,r16
									;
									ldi	r16,255	;KEIN auswahlmen (255)
									st	z+,r16
									;
									ldi	r16,255	;KEIN sub-auswahlmen (255)
									st	z+,r16
									;
									ldi	r16,0	;infotext 0
									st	z+,r16
									;
									ldi	r16,255	;KEINE graphische funktion (255)
									st	z+,r16
									;darstellen
									call	_sys01IF
							



;............................................................................
;spi als slave initialisieren (auch interrupt freigeben)
sei
call	_SPIslaveINIT
;............................................................................

;............................................................................
;MAIN-LOOP
;............................................................................
_MAINloop:
;bei aktiver spi die anderen module disabled
lds	r16,comFLAG
sbrs	r16,spiBUSY		;1=spi soeben aktiv...
rjmp	_MAINloopB	
;hier reset(pind3)bei ne'm spi hnger !!
;A)key pressed
sbis	pind,pind3
rjmp	_SOFTreset		;new start...
rjmp	_MAINloop
;--------------------------------------------------
;
_MAINloopB:
;hier reset(pind3)bei ne'm hnger !!
;A)key pressed
sbis	pind,pind3
rjmp	_SOFTreset		;new start...
;nun spi daten interpretieren (falls vorhanden)
call	_sys01IF	;daten interpretieren
;drehratendecoder inkl. curdorsteuerung aufrufen
call	_graphCURSOR
;graphische symbole darstellen	
call	_Gsym
jmp	_MAINloop
;-----------------soft reset------------------
_SOFTreset:
	cli
	jmp	_initSYS
	











;*******************************************************************************************
;include files
.include "Gcursor.asm"
.include "sysIF.asm"
.include "spi.asm"
.include "_SPIinit.asm"
.include "font_table.asm"
;.include "sinus.asm"
.include "GLCDcom.asm"
.include "Gtxt.asm"
.include "Grect.asm"
;.include "Gcircle.asm"
;.include "Gline.asm"
;.include "Gplot.asm"
.include "calcPAGEnDIS.asm"
;.include "MultiNETtbl_III.asm"
.include "conceptXM1_tbl.asm"
.include "graph_tbl.asm"
.include "Gsym.asm"
.include "Blight.asm"
.include "RC5decoderNEW.asm"
;.include "Panasonic_EncoderII.asm"
.exit



