
;*******************************************************************
;DRWrectangle
;- konstruktion von reckteckigen rahmen
;  und gefllten rechtecken
;- im rechteckigen bereich liegende daten
;  knnen belassen oder komplett berschrieben
;  (auch lschen...) werden
;
;bentigte parameter:
;- graphBOXposXte = x-koordinate obere linke ecke
;- graphBOXposYte = y-koordinate obere linke ecke
;- xCHARsiz	    = x-gre(lnge)
;- yCHARsiz	    = y-gre(hhe)
;- LINEth	    = linienstrke
;
;bentigte flags (graphBOXflTE)	
;- graphBOXfull	0=ergnzen / 1=komplett fllen
;- graphBOXcont	0=volles rechteck / 1= nur rechteckiger rahmen
;- graphBOXclr	0=normaler rahmen / 1= rahmen lschen
;- graphBOXinv	0=normal / 1=invertiert		

;**********************************************************************
_Grectangle:
ldi	r16,0
sts	graphBOXposXte,r16
sts	xPOSabs,r16
;
sts	graphBOXposYte,r16
sts	yPOSabs,r16
;
ldi	r16,128
sts	xCHARsiz,r16
;
ldi	r16,64
sts	yCHARsiz,r16
;
ldi	r16,1
sts	LINEth,r16
;
clr	r16
sbr	r16,1<<graphBOXcont
sbr	r16,1<<graphBOXfull
;sbr	r16,1<<graphBOXclr
;sbr	r16,1<<graphBOXinv
sts	graphBOXflTE,r16


call	_DRWrectangle
jmp	_txtMOD	;_Gbargraph	;_Gplot	;_Gline	;_Gcircle













;*******************************************************************
;DRWbargraph (unterfunktion rectangle)
;- konstruktion eines bargraphbalkens mit rahmen
;- im rechteckigen bereich liegende daten werden 
;  komplett berschrieben
;
;bentigte parameter:
;- graphBOXposXte = x-koordinate obere linke ecke
;- graphBOXposYte = y-koordinate obere linke ecke
;- xCHARsiz	    = x-gre(lnge)
;- yCHARsiz	    = y-gre(hhe)
;- LINEth	    = linienstrke
;
;bentigte flags (graphBOXflTE)
;- graphBOXfull	0=ergnzen / 1=komplett fllen	
;- graphBOXbar	0=standard rectangle funktionen / 1=bargraph
;**********************************************************************
	
;zuerst prozent-text setzen....
_Gbar:
	;text adressieren
	ldi	zh,high(PROZtable*2)
	ldi	zl,low(PROZtable*2)
	sts	TXTpointL,zl	;adresspointer sichern
	sts	TXTpointH,zh
	;x-zoomfaktor
	ldi	r16,1	;2		wird spter von anderer stelle geliefert +++ 
	sts	CHARfactorX,r16	
	;y-zoomfaktor
	ldi	r16,1	;2		wird spter von anderer stelle geliefert +++ 
	sts	CHARfactorY,r16	
	;x-pos txtBOX
	ldi	r16,5	;	wird spter von anderer stelle geliefert +++
	sts	graphBOXposXte,r16
	;y-pos txtBOX
	ldi	r16,33
	sts	graphBOXposYte,r16
	;
	clr	r16
	;sbr	r16,1<<graphBOXcont
	sbr	r16,1<<graphBOXfull
	;sbr	r16,1<<graphBOXinv
	sts	graphBOXflTE,r16

	call	_GtxtMOD





_Gbargraph:
	clr	r16
	sts	paraB,r16
	sts	paraA,r16
_GbargraphX:
	;x origin
	ldi	r16,5
	sts	graphBOXposXte,r16		;+++ wird spter von extern geliefert
	sts	xPOSabs,r16
	;y origin
	ldi	r16,20
	sts	graphBOXposYte,r16		;+++
	sts	yPOSabs,r16
	;xCHARsiz nicht verndern
	;bargraph umfasst 100 dots !
	ldi	r16,1
	sts	LINEth,r16			;+++
	;linie *2
	ldi	r17,2
	mul	r16,r17
	ldi	r16,100
	add	r16,r0	
	sts	xCHARsiz,r16
	;
	ldi	r16,10
	sts	yCHARsiz,r16		;+++
	;
	;
	clr	r16
	sbr	r16,1<<graphBOXbar
	sbr	r16,1<<graphBOXfull
	;sbr	r16,1<<graphBOXinv
	sts	graphBOXflTE,r16		;+++

	;test-loop
	;aufsteigend....
_barLOOP:
	call	_DRWrectangle

	lds	r16,paraB
	cpi	r16,0xff
	breq	_barLOOPx
	inc	r16
	sts	paraB,r16
	sts	paraA,r16
	ldi	r17,0xff
	ldi	r18,0xff
_barLOOPz:
	dec	r17
	tst	r17	
	brne	_barLOOPz
	ldi	r17,0xff
	dec	r18
	tst	r18
	brne	_barLOOPz
	jmp	_GbargraphX
	;
_barLOOPx:
	jmp	_Gbargraph











;*******************************************************************
;DRWtext
;- konstruktion von zeichen variabler gre
;  basierend auf einer font-tabelle
;- im rechteckigen textbereich liegende daten
;  werden komplett berschrieben oder ergnzt
;
;bentigte parameter:
;- graphBOXposXte 	= x-koordinate obere linke ecke
;- graphBOXposYte 	= y-koordinate obere linke ecke
;- CHARfactorX   	= x-zeichen vergrerungsfaktor
;- CHARfactorY   	= y-zeichen vergrerungsfaktor
;- TXTpointL    	= flash-texttabellenstartadresse L
;- TXTpointH    	= flash-texttabellenstartadresse H
;
;bentigte flags (graphBOXflTE)	
;- graphBOXinv	0=normal / 1=invertiert		

;**********************************************************************
_txtMOD:
	;text adressieren
	ldi	zh,high(TXTtableII*2)
	ldi	zl,low(TXTtableII*2)
	sts	TXTpointL,zl	;adresspointer sichern
	sts	TXTpointH,zh

	;x-zoomfaktor
	ldi	r16,2	;2		wird spter von anderer stelle geliefert +++ 
	sts	CHARfactorX,r16	
	;y-zoomfaktor
	ldi	r16,2	;2		wird spter von anderer stelle geliefert +++ 
	sts	CHARfactorY,r16	
	;x-pos txtBOX
	ldi	r16,5	;	wird spter von anderer stelle geliefert +++
	sts	graphBOXposXte,r16
	;y-pos txtBOX
	ldi	r16,2
	sts	graphBOXposYte,r16
	;
	clr	r16
	;sbr	r16,1<<graphBOXcont
	sbr	r16,1<<graphBOXfull
	;sbr	r16,1<<graphBOXinv
	sts	graphBOXflTE,r16
	call	_GtxtMOD

_txtLOOP:
	jmp	_Gbar

















;*******************************************************************
;DRWcircle
;- konstruktion eines kreises
;
;- im kreisfrmigen bereich liegende daten
;  knnen belassen oder komplett berschrieben
;  (auch lschen...) werden
;
;bentigte parameter:
;- graphBOXposXte = x-koordinate obere linke ecke
;- graphBOXposYte = y-koordinate obere linke ecke
;- radCIRCLE    = kreisradius
;
;bentigte flags (graphBOXflTE)	
;- graphBOXinv	0=normal / 1=invertiert		

;**********************************************************************
_Gcircle:
ldi	r16,15
sts	radCIRCLE,r16
;
clr	r16
sts	graphBOXflTE,r16
;
;x-pos GRAPH BOX
ldi	r16,1		;	wird spter von anderer stelle geliefert +++
sts	graphBOXposXte,r16
sts	xPOSabs,r16		;als absolute x-position speichern
;y-pos GRAPH BOX
ldi	r16,10
sts	graphBOXposYte,r16
sts	yPOSabs,r16		;als absolute y-position speichern

_Cloop:
	;test
call	_DRWcircle
	;
;	jmp	test




lds	r16,graphBOXposXte
inc	r16
inc	r16
inc	r16
inc	r16
inc	r16
sts	graphBOXposXte,r16
;lds	r16,graphBOXposYte
;inc	r16
;sts	graphBOXposYte,r16
cpi	r16,96
brlo	_Cloop

test:
	jmp _txtMOD	






;*******************************************************************
;PLOTline
;- konstruktion einer linie
;
;- im bereich liegende daten
;  knnen belassen oder komplett berschrieben
;  (auch lschen...) werden
;
;bentigte parameter:
;- graphBOXposXte = absolute x-koordinate (obere linke ecke)
;- graphBOXposYte = absolute y-koordinate (obere linke ecke)
;- lgtLINE	    = relative linienlnge
;- alphaLINE    = linienwinkel (30' schritte)
;- quadLINEfl   = flagvariable (plotquadrant)
;
;flags zu <quadLINEfl>:
;- PxMy	    = quadrant rechts oben (+x,-y)
;- PxPy	    = quadrant rechts unten(+x,+y)
;- MxPy	    = quadrant links unten (-x,+y)
;- MxMy	    = quadrant links oben  (-x,-y)
;
;weitere bentigte flags <graphBOXflTE>:	
;- graphBOXinv	0=normal / 1=invertiert		

;**********************************************************************
_Gline:
ldi	r16,20
sts	lgtLINE,r16
;
ldi	r16,0		;0grad
sts	alphaLINE,r16
;
clr	r16
sts	graphBOXflTE,r16
;
sbr	r16,1<<PxMy
sts	quadLINEfl,r16
;
;x-pos GRAPH BOX
ldi	r16,50		;	wird spter von anderer stelle geliefert +++
sts	graphBOXposXte,r16
;y-pos GRAPH BOX
ldi	r16,30
sts	graphBOXposYte,r16
;
_Gloop:
	call	_PLOTline
	lds	r16,alphaLINE
	ldi	r17,4
	add	r16,r17
	sts	alphaLINE,r16
	cpi	r16,180
	brsh	newQUAD	
	;test
	jmp _Gloop



newQUAD:
	lds	r16,quadLINEfl
	lsl	r16
	cpi	r16,0x10
	breq	LINEready
	sts	quadLINEfl,r16
	clr	r16
	sts	alphaLINE,r16
	jmp	_Gloop
	
LINEready:
	jmp	LINEready





;*******************************************************************
;PLOTpix
;- plot pixel an beliebiger stelle
;
;- im bereich liegende daten
;  knnen belassen oder komplett berschrieben
;  (auch lschen...) werden
;
;bentigte parameter:
;- graphBOXposXte = absolute x-koordinate (obere linke ecke)
;- graphBOXposYte = absolute y-koordinate (obere linke ecke)
;- xPLOT	    = relative x-koordinate
;- yPLOT        = relative y-koordinate
;
;weitere bentigte flags <graphBOXflTE>:	
;- graphBOXinv	0=normal / 1=invertiert		

;**********************************************************************
_Gplot:
;x-pos GRAPH BOX
ldi	r16,0		;	wird spter von anderer stelle geliefert +++
sts	graphBOXposXte,r16
;y-pos GRAPH BOX
ldi	r16,10
sts	graphBOXposYte,r16
;normal/invers
clr	r16
sts	graphBOXflTE,r16
;rel x-koordinate
ldi	r16,1
sts	xPLOT,r16
;rel y-koordinate
ldi	r16,1
sts	yPLOT,r16

;test 
_PIXloop:
	call	_PLOTpix	;pixel setzen
	lds	r16,xPLOT
	lds	r18,yPLOT
	ldi	r17,1
	add	r16,r17
	cpi	r16,30
	breq	_PIXloopOV
	sts	xPLOT,r16
	add	r18,r17
	cpi	r18,40
	breq	_PIXloopOV
	sts	yPLOT,r18
	jmp	_PIXloop
_PIXloopOV:
	call	_PLOTpix	;pixel setzen
	lds	r16,xPLOT
	lds	r18,yPLOT
	ldi	r17,1
	add	r16,r17
	cpi	r16,displayCOLmax
	brsh	_PIXloopRD
	sts	xPLOT,r16
	ldi	r17,1
	sub	r18,r17
	tst	r18
	breq	_PIXloop
	sts	yPLOT,r18
	jmp	_PIXloopOV

_PIXloopRD:
jmp	_PIXloopRD


