;*****************************************************************************************
;sub-kreisberechnung
;***************************************************************************************** 
;variablen:
;radCIRCLE = radius (max.65)
;radCNT    = winkelposition (0-180) 30'schritte == 90
;plotY     = errechneter y-punkt
;plotX     = errechneter x-punkt
;*****************************************************************************************

;y-koordinate via sinus berechnen
_subCIRCLE:
	ldi	zh,high(cosinTABLE*2)
	ldi	zl,low(cosinTABLE*2)
	lds	r3,radCNT	;winkelposition laden
	ldi	r16,2
	mul	r3,r16	;tabellenposition berechnen
	add	zl,r0
	adc	zh,r1
	;lsb holen...
	lpm	r2,z+
	;msb holen
	lpm	r3,z
	;nun a=c*sin(alpha)
	clr	r5
	lds	r4,radCIRCLE
	mul	r2, r4	
	movw	r7:r6, r1:r0
	mul	r3, r4		
	add	r7, r0
	mul	r5, r2	
	add	r7, r0
	;result r6/r7
	mov	zl,r6
	mov	zh,r7
	;/1000
	call	_divTHOUSAND	
	sts	yPLOT,r4	;y-koordinate speichern
	;
;x-koordinate via cosinus berechnen
	ldi	zh,high(cosinTABLE*2)
	ldi	zl,low(cosinTABLE*2)
	lds	r3,radCNT	;winkelposition laden
	ldi	r16,179	
	sub	r16,r3
	mov	r3,r16
	;
	ldi	r16,2
	mul	r3,r16	;tabellenposition berechnen
	add	zl,r0
	adc	zh,r1
	;lsb holen...
	lpm	r2,z+
	;msb holen
	lpm	r3,z
	;nun a=c*cosin(alpha)
	clr	r5
	lds	r4,radCIRCLE
	mul	r2, r4	
	movw	r7:r6, r1:r0
	mul	r3, r4		
	add	r7, r0
	mul	r5, r2	
	add	r7, r0
	;result r6/r7
	mov	zl,r6
	mov	zh,r7
	;/1000
	call	_divTHOUSAND	
	sts	xPLOT,r4
	ret



;****************************************************************************************
;sub division/1000  (zl lsb / zh msb)
;****************************************************************************************
_divTHOUSAND:
.equ	FIFEH	=	500	
.equ	THOU	=	1000
.equ  TTHOU	=	10000
	clr	r4	;1000 er counter
	ldi	yl,low(TTHOU)
	ldi	yh,high(TTHOU)
	ldi	xl,10
	;wie oft gehn 10000 rein?
_TTHOUloop:
	;>=10000
	cpi	zl,low(TTHOU)	
	ldi	xh,high(TTHOU)	
	cpc	zh,xh		
	brlo	_THOUloop
	;-10000
	sub	zl,yl		;low
	sbc	zh,yh		;high
	add	r4,xl		;+10000
	rjmp	_TTHOUloop
	;
	;wie oft gehn 1000 rein
_THOUloop:
	ldi	yl,low(THOU)
	ldi	yh,high(THOU)
	ldi	xl,1
_THOUloopGO:
	;>=1000
	cpi	zl,low(THOU)	
	ldi	xh,high(THOU)	
	cpc	zh,xh		
	brlo	_THOUloopEX
	;-1000
	sub	zl,yl		;low
	sbc	zh,yh		;high
	add	r4,xl		;+1000
	rjmp	_THOUloopGO

	;rest >500 (dann tausend +1)
_THOUloopEX:
	cpi	zl,low(FIFEH)	
	ldi	xh,high(FIFEH)	
	cpc	zh,xh		
	brlo	_THOUloopREADY
	;>=500 == +1000
	inc	r4
_THOUloopREADY:
	ret




	
	









;********************************************************************************************
;(co)sinus table 30'schritte (0-90 grad) / faktor 1000
;********************************************************************************************
cosinTABLE:
.dw	0,9,18,26,35,44,52,61,70,79,87,96,105,113,122,131	;..0 grad sinus / 90 grad cosinus
.dw	139,148,156,165,174,182,191,199,208,216,225,233,242
.dw	250,259,267,276,284,292,301,309,317,326,343,342,350
.dw	358,367,375,383,391,399,407,415,423,431,438,446,454
.dw	462,470,477,485,492,500,508,515,523,530,537,545,552
.dw	559,566,574,581,588,595,602,609,616,623,629,636,643
.dw	649,656,663,669,676,682,688,695,701,707			;..45 grad (co)sinus
.dw	713,719,725,731,737,743,749,755,760,766,772,777,783
.dw	788,793,799,804,809,814,819,824,829,834,839,843,848
.dw	853,857,862,866,870,875,879,883,887,891,895,899,903
.dw	906,910,914,917,921,924,927,930,934,937,940,943,946
.dw	948,951,954,956,959,961,964,966,968,970,972,974,976
.dw	978,980,982,983,985,986,988,989,990,991,993,994,995
.dw	996,997,998,998,999,999,999,1000,1000,1000,1000		;..90 grad sinus / 0 grad cosinus

.exit


;          /|
;        /  |
;  c   /    |
;    /      |a
;  /alpha   |
;/__________|
;    b
;
;a=c*sin(alpha)
;b=c*cos(alpha)

;INFO: c==radius
