;*************************************************************************
;system-interface
;*************************************************************************
;aufgabe:
;- system-schnittstelle 
;- interpretation der eingangsdaten (comBUF)
;- den parametern index-marken zuweisen,entsprechend der position innerhalb des textes
;- display positions koodinaten setzen
;
;
;info:
;a)datenstruktur: <para.function><basismenu X><auswahlmenu X>
;			<subauswahlmenu X><infotextbaustein X><graph.baustein X>
;			<PARAx><paraPOSx><paraMINx><paraMAXx>...
;
;b)parameter funktionen (tabelle):
;
;Bit                           |7  |6  |5  |4  |3  |2  |1  |0  |Hex  |
;______________________________|___|___|___|___|___|___|___|___|_____|
;                              |edi|par|num|bar|p3 |p2 |p1 |p0 |     |
;______________________________|___|___|___|___|___|___|___|___|_____|
;edit alphnum.parameter        | x | x |   |   |*  |*  |*  |*  |0x   |
;______________________________|___|___|___|___|___|___|___|___|_____|
;edit num. parameter           | x | x | x |   |*  |*  |*  |*  |0x   |
;______________________________|___|___|___|___|___|___|___|___|_____|
;edit num. bargraph-parameter  | x | x | x | x |*  |*  |*  |*  |0x   |
;______________________________|___|___|___|___|___|___|___|___|_____|
;display alphanum.parameter    |   | x |   |   |*  |*  |*  |*  |0x   |
;______________________________|___|___|___|___|___|___|___|___|_____|
;display num.parameter 		   |   | x | x |   |*  |*  |*  |*  |0x   |
;______________________________|___|___|___|___|___|___|___|___|_____|
;display num. bargraph-param.  |   | x | x | x |*  |*  |*  |*  |0x   |
;______________________________|___|___|___|___|___|___|___|___|_____|
;keine parameter-funktion      |*  |   |*  |*  |*  |*  |*  |*  |0x   |
;______________________________|___|___|___|___|___|___|___|___|_____|
;
;p0-p3=anzahl angefgter parameter
;numG	=numerische darstellung
;parG =parameter
;barG =bargraph
;ediG =parameter editieren
;
;*******************************************************************************

_sys01IF:
	lds	r16,comFLAG
	sbrc	r16,newBUFdata	;1=neue daten im buffer
	rjmp	_sys02IF
	jmp	_sysIFback		;keine neuen daten == zurck
_sys02IF:
	sbrs	r16,spiBUSY		;1=spi soeben aktiv...
	rjmp  _sys03IF
	jmp	_sysIFback		;zwar neue daten aber nicht vollstndig == zurck	
	;beginne verarbeitung
_sys03IF:
	clr		r16
	sts	GsymFL,r16
	;
	ldi	zh,high(comBUF)
	ldi	zl,low(comBUF)
	;parameter.funktionsbyte laden & temporr sichern
	ld	r17,z
	sts	paraFUNC,r17     
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;die nchsten 5byte enthalten die text-,graph-adresspointer
	;0-254 == pointer
	;255   == nicht relevant
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;+++++a)basistext
	;adresse holen
	ldi	zh,high(comBUF)	
	ldi	zl,low(comBUF)
	adiw	zh:zl,1		
	ld	r17,z
	cpi	r17,0xff	
	breq	_sys04IF
	;kein cursor erlaubt
	lds	xl,curMODflTE
	cbr	xl,1<<BOXcursor ;cursorroutine disable
	sts	curMODflTE,xl
	;
	call	_disBT		;display basistext X
	;
	;
;+++++b)hauptauswahlmen ?
_sys04IF:
	;adresse holen
	ldi	zh,high(comBUF)	
	ldi	zl,low(comBUF)
	adiw	zh:zl,2		
	ld	r17,z
	cpi	r17,0xff
	breq	_sys04IFex
	;cursor erlaubt
	lds	xl,curMODflTE
	sbr	xl,1<<BOXcursor ;cursorroutine enable
	sts	curMODflTE,xl
	;
	;
	;bei edit mode indexe nicht verndern!
	sbrc	xl,curEDIT
	rjmp	_sys04IFgo
	;auch bei aktivem cursor index belassen!
	sbrc	xl,BOXactiv
	rjmp	_sys04IFgo
	;
	;prfe ob letzte funktion 
	;= neuer funktion
	lds	xh,tempAUSmain
	cp	r17,xh
	breq _sys04IFgo			;ist gleich == cursor bleibt an position
	;
	;-> erstmaliger aufruf
	;cursor initialisieren
	lds	xl,curMODflTE
	cbr	xl,1<<curINIT ;cursorroutine enable
	sts	curMODflTE,xl
;indexe =0
	;mit upperINDEX=0 starten
	clr	xl
	sts	upperINDEX,xl
	;mir cursorINDEX=0 starten
	clr	xl
	sts	curINDEX,xl
	;temporre sub-auswahlfunktion == 255
	ldi		xl,0xff
	sts	tempAUSsub,xl
	;
	;
	;
_sys04IFgo:
	sts	tempAUSmain,r17		;auswahl temporr speichern
	call	_disAM		;display auswahlmen X
	jmp		_sys05IF
	;
_sys04IFex:
	sts	tempAUSmain,r17		;auswahl temporr speichern
	;
	;
;+++++c)sub-auswahlmen ?
_sys05IF:
	;adresse holen
	ldi	zh,high(comBUF)	
	ldi	zl,low(comBUF)
	adiw	zh:zl,3		
	ld	r17,z
	cpi	r17,0xff
	breq	_sys05IFex
	;cursor erlaubt
	lds	xl,curMODflTE
	sbr	xl,1<<BOXcursor ;cursorroutine enable
	sts	curMODflTE,xl
	;
	;
	;bei edit mode indexe nicht verndern!
	sbrc	xl,curEDIT
	rjmp	_sys05IFgo
	;auch bei aktivem cursor index belassen!
	sbrc	xl,BOXactiv
	rjmp	_sys05IFgo
	;
	;prfe ob letzte funktion 
	;= neuer funktion
	lds	xh,tempAUSsub
	cp	r17,xh
	breq _sys05IFgo			;ist gleich == cursor bleibt an position
	;
	;
	;-> erstmaliger aufruf
	;cursor initialisieren
	lds	xl,curMODflTE
	cbr	xl,1<<curINIT ;cursorroutine enable
	sts	curMODflTE,xl
	;
;indexe =0
	;mit upperINDEX=0 starten
	clr	xl
	sts	upperINDEX,xl
	;mir cursorINDEX=0 starten
	clr	xl
	sts	curINDEX,xl
	;temporre auswahlfunktion == 255
	ldi		xl,0xff
	sts	tempAUSmain,xl
	;
	;
	;
_sys05IFgo:
	sts	tempAUSsub,r17		;auswahl temporr speichern
	call	_disSAM		;display sub-auswahlmen X
	jmp	_sys06IF
	;
_sys05IFex:
	sts	tempAUSsub,r17		;auswahl temporr speichern
	;
	;
;+++++d)infotext ?
_sys06IF:
	;adresse holen
	ldi	zh,high(comBUF)	
	ldi	zl,low(comBUF)
	adiw	zh:zl,4		
	ld	r17,z
	cpi	r17,0xff
	breq	_sys07IF
	;kein cursor erlaubt
	lds	xl,curMODflTE
	cbr	xl,1<<BOXcursor ;cursorroutine disable
	sts	curMODflTE,xl
	;
	ldi	zh,high(comBUF)	
	ldi	zl,low(comBUF)
	adiw	zh:zl,5		
	ld	r17,z	;graph.funktion holen
	sbrs	r17,2	;bigTXT?
	rjmp	_sys06IFbig
	rjmp	_sys06IFz
_sys06IFz:
	ldi	zh,high(comBUF)	
	ldi	zl,low(comBUF)
	adiw	zh:zl,4		
	ld	r17,z
	call	_disIT		;display infotext X
	jmp	_sys07IF
	;
_sys06IFbig:
	ldi	zh,high(comBUF)	
	ldi	zl,low(comBUF)
	adiw	zh:zl,4		
	ld	r17,z
	call	_disITbig	;display groen INFOTEXT
	jmp	_sys08IF		;keine weitere graph funktion!
	;
	;
;+++++e)graphischer Baustein ?
_sys07IF:
	;adresse holen
	ldi	zh,high(comBUF)	
	ldi	zl,low(comBUF)
	adiw	zh:zl,5	
	ld	r17,z
	cpi	r17,0xff
	breq	_sys08IF
	;cursor nicht erlaubt
	lds	xl,curMODflTE
	cbr	xl,1<<BOXcursor ;cursorroutine disable
	sts	curMODflTE,xl
	sts	graphFU,r17		;speichern
	;
	clr	r16
	sbr	r16,1<<showSYM
	sts	GsymFL,r16


_sys08IF:
	;spi data flag lschen (ist ja fertig!)
	lds	xl,comFLAG
	cbr	xl,1<<newBUFdata	;noch keine bufferdaten vorhanden
	sts	comFLAG,xl
	;hier spi wieder als slave aktivieren
	call	_SPIslaveINIT

	;
	;.......
	jmp	_sysIFback




;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;+++display basistext (nicht scrollbar)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_disBT:
	;adressiere basistext via tabelle
	ldi	zh,high(_txtCALLbasis*2)
	ldi	zl,low(_txtCALLbasis*2)
	;pointer *2
	ldi	r18,2
	mul	r17,r18
	;startadresse +pointer   =LSB
	add	zl,r0
	adc	zh,r1
	lpm	xl,z+
	;startadresse +pointer+1 =MSB
	lpm	xh,z
	;nun sichern...
	sts	TXTstartL,xl
	sts	TXTstartH,xh
	;kopiere das ganze ins sram
	call	_copySFa
	;
	;
	;
;...................................................................................................
		lds	r16,curMODflTE
		sbrc	r16,BOXactiv
		rjmp	_disBTgo
;displayinhalte komplett lschen & ueren rahmen (aber nur wenn kein cursor aktiv ist!)konstruieren
ldi	r16,0
sts	graphBOXposXte,r16
sts	xPOSabs,r16
;
sts	graphBOXposYte,r16
sts	yPOSabs,r16
;
ldi	r16,128
sts	xCHARsiz,r16
;
ldi	r16,64
sts	yCHARsiz,r16
;
ldi	r16,1
sts	LINEth,r16
;
clr	r16
sbr	r16,1<<graphBOXcont
sbr	r16,1<<graphBOXfull
;sbr	r16,1<<graphBOXclr
;sbr	r16,1<<graphBOXinv
sts	graphBOXflTE,r16
call	_DRWrectangle
;..............................................................................................


_disBTgo:
	;++++++++++++++++++
	;hier position der
	;graphBOXbestimmen
	;& text darstellen
	;++++++++++++++++++
	;
	;x-zoomfaktor
	ldi	r16,1	;2		
	sts	CHARfactorX,r16	
	;y-zoomfaktor
	ldi	r16,2	;2	
	sts	CHARfactorY,r16	
	;x-pos txtBOX
	ldi	r16,1	
	sts	graphBOXposXte,r16
	;y-pos txtBOX
	ldi	r16,2
	sts	graphBOXposYte,r16
	;
	clr	r16
	;sbr	r16,1<<graphBOXcont
	sbr	r16,1<<graphBOXfull
	;sbr	r16,1<<graphBOXinv
	sts	graphBOXflTE,r16
	;& text schreiben
	call	_GtxtMOD
	;
	;++++++++++++++++++
	;hier position der
	;graphBOXbestimmen
	;& rahmen darstellen
	;++++++++++++++++++
	ldi	r16,0
	sts	graphBOXposXte,r16
	sts	xPOSabs,r16
	;
	sts	graphBOXposYte,r16
	sts	yPOSabs,r16
	;
	ldi	r16,128
	sts	xCHARsiz,r16
	;
	ldi	r16,18
	sts	yCHARsiz,r16
	;
	ldi	r16,1
	sts	LINEth,r16
	;
	clr	r16
	sbr	r16,1<<graphBOXcont
	;sbr	r16,1<<graphBOXfull
	;sbr	r16,1<<graphBOXclr
	;sbr	r16,1<<graphBOXinv
	sts	graphBOXflTE,r16
	call	_DRWrectangle


	ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;+++display auswahlmen (scrollbar) & parameterdarstellung
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_disAM:
	;adressiere basismentext via tabelle
	ldi	zh,high(_txtCALLauswahl*2)
	ldi	zl,low(_txtCALLauswahl*2)
	;pointer *2
	ldi	r18,2
	mul	r17,r18
	;startadresse +pointer   =LSB
	add	zl,r0
	adc	zh,r1
	lpm	xl,z+
	;startadresse +pointer+1 =MSB
	lpm	xh,z
	;nun sichern...
	sts	TXTstartL,xl
	sts	TXTstartH,xh
	;kopiere das ganze ins sram
	call	_copySFa
	;prfe ob parameter vorhanden
	call	_disPARA

	;
	;++++++++++++++++++
	;hier position der
	;graphBOXbestimmen
	;++++++++++++++++++
	;
	;x-zoomfaktor
	ldi	r16,1	;2		
	sts	CHARfactorX,r16	
	;y-zoomfaktor
	ldi	r16,1	;2	
	sts	CHARfactorY,r16	
	;x-pos txtBOX
	ldi	r16,3	
	sts	graphBOXposXte,r16
	;y-pos txtBOX
	ldi	r16,20
	sts	graphBOXposYte,r16
	;
	clr	r16
	;sbr	r16,1<<graphBOXcont
	sbr	r16,1<<graphBOXfull
	;sbr	r16,1<<graphBOXinv
	sts	graphBOXflTE,r16
	call	_GtxtMOD

	ret

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;+++display sub-auswahlmen (scrollbar & parameterdarstellung-editierbar)
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_disSAM:
	;adressiere basismentext via tabelle
	ldi	zh,high(_txtCALLsubauswahl*2)
	ldi	zl,low(_txtCALLsubauswahl*2)
	;pointer *2
	ldi	r18,2
	mul	r17,r18
	;startadresse +pointer   =LSB
	add	zl,r0
	adc	zh,r1
	lpm	xl,z+
	;startadresse +pointer+1 =MSB
	lpm	xh,z
	;nun sichern...
	sts	TXTstartL,xl
	sts	TXTstartH,xh
	;kopiere das ganze ins sram
	call	_copySFa
	;prfe ob parameter vorhanden
	call	_disPARA

	;++++++++++++++++++
	;hier position der
	;graphBOXbestimmen
	;++++++++++++++++++
	;
	;x-zoomfaktor
	ldi	r16,1	;2		
	sts	CHARfactorX,r16	
	;y-zoomfaktor
	ldi	r16,1	;2	
	sts	CHARfactorY,r16	
	;x-pos txtBOX
	ldi	r16,3	
	sts	graphBOXposXte,r16
	;y-pos txtBOX
	ldi	r16,20
	sts	graphBOXposYte,r16
	;
	clr	r16
	;sbr	r16,1<<graphBOXcont
	sbr	r16,1<<graphBOXfull
	;sbr	r16,1<<graphBOXinv
	sts	graphBOXflTE,r16
	call	_GtxtMOD

	ret




;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;+++display infotext (nicht scrollbar & parameter darstellung)
;   anordnung unterer displaybereich
;   & obere abschlulinie
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_disIT:
	;adressiere basismentext via tabelle
	sts	helpA,r17	;textnummer
	ldi	zh,high(_txtCALLinfo*2)
	ldi	zl,low(_txtCALLinfo*2)
	;pointer *2
	ldi	r18,2
	mul	r17,r18
	;startadresse +pointer   =LSB
	add	zl,r0
	adc	zh,r1
	lpm	xl,z+
	;startadresse +pointer+1 =MSB
	lpm	xh,z
	;nun sichern...
	sts	TXTstartL,xl
	sts	TXTstartH,xh
	;kopiere das ganze ins sram
	call	_copySFa
	;prfe ob parameter vorhanden
	call	_disPARA
	;falls	displayeinstellung gewhlt, dann
	;tePARx entsprechend speichern !
	lds	r17,helpA
	cpi	r17,86	;brightness
	brne	_disITcontr
	lds	r17,tePARx
	out	ocr1al,r17
	sts	NORMlight,r17
	jmp	_disITgo
_disITcontr:
	cpi	r17,87	;contrast
	brne	_disITgo
	lds	r17,tePARx
	out	ocr0,r17
_disITgo:
	;++++++++++++++++++
	;hier position der
	;graphBOXbestimmen
	;++++++++++++++++++
	;
	;x-zoomfaktor
	ldi	r16,1	;2		
	sts	CHARfactorX,r16	
	;y-zoomfaktor
	ldi	r16,1	;2	
	sts	CHARfactorY,r16	
	;x-pos txtBOX
	ldi	r16,3	
	sts	graphBOXposXte,r16
	;y-pos txtBOX
	ldi	r16,54
	sts	graphBOXposYte,r16
	;
	clr	r16
	;sbr	r16,1<<graphBOXcont
	sbr	r16,1<<graphBOXfull
	;sbr	r16,1<<graphBOXinv
	sts	graphBOXflTE,r16
	call	_GtxtMOD





	;prfe ob parameter zustzlich als bargraph dargestellt wirde
	lds		r16,paraFUNC
	sbrs 	r16,barG	;1=bargraph
	rjmp	_disITnobar
;	;.....................
	;bargraph
	;.....................
	;
	;text adressieren
	ldi	zh,high(PROZtable*2)
	ldi	zl,low(PROZtable*2)
	sts	TXTstartL,zl	;adresspointer sichern
	sts	TXTstartH,zh
	;kopiere das ganze ins sram
	call	_copySFa

	;x-zoomfaktor
	ldi	r16,1	;2		wird spter von anderer stelle geliefert +++ 
	sts	CHARfactorX,r16	
	;y-zoomfaktor
	ldi	r16,1	;2		wird spter von anderer stelle geliefert +++ 
	sts	CHARfactorY,r16	
	;x-pos txtBOX
	ldi	r16,5	;	wird spter von anderer stelle geliefert +++
	sts	graphBOXposXte,r16
	;y-pos txtBOX
	ldi	r16,39
	sts	graphBOXposYte,r16
	;
	clr	r16
	;sbr	r16,1<<graphBOXcont
	sbr	r16,1<<graphBOXfull
	;sbr	r16,1<<graphBOXinv
	sts	graphBOXflTE,r16
	call	_GtxtMOD
	;
	lds	r16,tePARx
	sts	paraA,r16
	;x origin
	ldi	r16,5
	sts	graphBOXposXte,r16		;+++ wird spter von extern geliefert
	sts	xPOSabs,r16
	;y origin
	ldi	r16,26
	sts	graphBOXposYte,r16		;+++
	sts	yPOSabs,r16
	;xCHARsiz nicht verndern
	;bargraph umfasst 100 dots !
	ldi	r16,1
	sts	LINEth,r16			;+++
	;linie *2
	ldi	r17,2
	mul	r16,r17
	ldi	r16,100
	add	r16,r0	
	sts	xCHARsiz,r16
	;
	ldi	r16,10
	sts	yCHARsiz,r16		;+++
	;
	;
	clr	r16
	sbr	r16,1<<graphBOXbar
	sbr	r16,1<<graphBOXfull
	;sbr	r16,1<<graphBOXinv
	sts	graphBOXflTE,r16		;+++
	call	_DRWrectangle
	;paraA restore (weil verndert !)
	lds	r16,tePARx
	sts	paraA,r16

	
_disITnobar:

	;++++++++++++++++++
	;hier position der
	;graphBOXbestimmen
	;& rahmen darstellen
	;++++++++++++++++++
	ldi	r16,0
	sts	graphBOXposXte,r16
	sts	xPOSabs,r16
	;
	ldi	r16,52
	sts	graphBOXposYte,r16
	sts	yPOSabs,r16
	;
	ldi	r16,128
	sts	xCHARsiz,r16
	;
	ldi	r16,12
	sts	yCHARsiz,r16
	;
	ldi	r16,1
	sts	LINEth,r16
	;
	clr	r16
	sbr	r16,1<<graphBOXcont
	;sbr	r16,1<<graphBOXfull
	;sbr	r16,1<<graphBOXclr
	;sbr	r16,1<<graphBOXinv
	sts	graphBOXflTE,r16
	call	_DRWrectangle

	ret


;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;+++display groen INFOTEXT /kein cursor erlaubt !
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_disITbig:
	;adressiere basismentext via tabelle
	ldi	zh,high(_BIGtxtCALL*2)
	ldi	zl,low(_BIGtxtCALL*2)
	;pointer *2
	ldi	r18,2
	mul	r17,r18
	;startadresse +pointer   =LSB
	add	zl,r0
	adc	zh,r1
	lpm	xl,z+
	;startadresse +pointer+1 =MSB
	lpm	xh,z
	;nun sichern...
	sts	TXTstartL,xl
	sts	TXTstartH,xh
	;kopiere das ganze ins sram
	call	_copySFa
	;prfe ob parameter vorhanden
	call	_disPARA
	;++++++++++++++++++
	;hier position der
	;graphBOXbestimmen
	;++++++++++++++++++
	;
	;x-zoomfaktor
	ldi	r16,1	;2		
	sts	CHARfactorX,r16	
	;y-zoomfaktor
	ldi	r16,1	;2	
	sts	CHARfactorY,r16	
	;x-pos txtBOX
	ldi	r16,3	
	sts	graphBOXposXte,r16
	;y-pos txtBOX
	ldi	r16,19
	sts	graphBOXposYte,r16
	;
	clr	r16
	;sbr	r16,1<<graphBOXcont
	sbr	r16,1<<graphBOXfull
	;sbr	r16,1<<graphBOXinv
	sts	graphBOXflTE,r16
	call	_GtxtMOD
	ret







;________________________________________________________________________________________________
;________________________________________________________________________________________________





;*****************************************************************
;sub -  parameter einbetten
;*****************************************************************
;->par      =nur wenn parameter-flag gesetzt
;->p0-p3    =max.15-parameter darstellbar
;->paraPOSx =parameter im textfeld platzieren
;->paraMINx =minimalwert parameter +(in parametertabelle sichern)
;->paraMAXx =maximalwert parameter +(in parametertabelle sichern)
;->PARAx	=parameter             +(in parametertabelle sichern)
;->
;*****************************************************************
;parametertabelle (paraACT):
;<index>,<paraFUNC>,<paraPOS>,<PARAx>,<paraMINx>,<paraMAXx>,.....
;*****************************************************************
_disPARA:
	lds	r18,paraFUNC
	sbrc	r18,parG		;0=keine parameter 
	rjmp	_disSAMpara
	jmp	_disBACK
	;
_disSAMpara:
	andi	r18,0b00001111
	sts	cntPAR,r18		;+++anzahl der bertragenen parameter sichern
	clr	r18
	sts	cntPARte,r18		; "               "			"
	ldi	zh,high(comBUF)	
	ldi	zl,low(comBUF)
	adiw	zh:zl,6		;hier beginnt die parameter sektion
	;adresse auf ersten
	;parameter gesetzt...
	;
_disSAMparaLOOPa:
	ld	r25,z+		;+++parameter x nach r25
	sts	tePAR,r25		;& sichern (wird whrend konvertierung verndert)
	sts	tePARx,r25		;& sichern (bleibt stabil !)

	;adresse sichern
	sts	comBUFadrL,zl
	sts	comBUFadrH,zh	;pointer auf pos!
	;
	ldi	r23,0x20
	ldi	r24,0x20
	lds	r18,paraFUNC
	sbrc	r18,numG		;1=binr 0=ascii
	rjmp	_paraKONascii	;binrwert nach ascii	

_disSAMparaLOOPb:
	;nun parameter in den 
	;patxBUF einfgen
	ldi	xh,high(patxBUF)
	ldi	xl,low(patxBUF)
	adiw	xh:xl,2 ;x-pointer auf erstem textzeichen
	;nun parameter position aus
	;comBUF holen
	lds	yh,comBUFadrH
	lds	yl,comBUFadrL
	ld	r16,y+	;parameter position
	sts	paraPOS,r16
	;
	sts	comBUFadrL,yl	;pointer auf min
	sts	comBUFadrH,yh
	;
	;zuerst den textindex suchen &speichern
	;

_disSAMparaLOOPc:
	ld	r17,x
	tst	r17
	breq	_disSAMparaNEW	;nix dabei= neuen parameter laden
	;new line ?
	cpi	r17,15
	breq	_disSAMparaLOOPd	;15=new line (wg.index)
	;position vergleichen
	tst	r16
	breq	_disSAMposOKz	;position ok == darstellen
	adiw	xh:xl,1		;nchstes zeichen...
	dec	r16
	jmp	_disSAMparaLOOPc
	;new line !
_disSAMparaLOOPd:
	adiw	xh:xl,2		;pointer +2
	jmp	_disSAMparaLOOPc
	;nchsten parameter
_disSAMparaNEW:
	jmp	_disBACKcheck


	;passt-index suchen...
_disSAMposOKz:
	sts	TXTpointH,xh
	sts	TXTpointL,xl
_disSAMposOKzz:
	ld	r17,x+
	;ende
	tst	r17
	breq	_disSAMindiSTORE	;0= ende
	;new line ?
	cpi	r17,15
	breq	_disSAMindiSTORE	;15=new line (wg.index)
	jmp	_disSAMposOKzz
	;
_disSAMindiSTORE:
	ld	r2,x	;index
	;alte pointer holen
	lds	xh,TXTpointH
	lds	xl,TXTpointL
	;
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;position parameterdarstellung erreicht....
	;->index in r2
	;->decodierten parameter in adressierte position bergeben
	;->rechtsbndige darstellung zu position !
_disSAMposOKx:
	ldi	yl,1
	clr	yh
	;1er an position speichern
	st	x,r25
_disSAMposOKbx:
	cpi	r24,0x20
	breq _disSAMposOKc		
	sub	xl,yl	;pointer-1
	sbc	xh,yh
	;10er speichern
	st	x,r24
_disSAMposOKcx:
	cpi	r23,0x20
	breq _disSAMposOKc
	sub	xl,yl	;ponter-1
	sbc	xh,yh
	st	x,r23
	;fertig...
_disSAMposOKc:
	;
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;position parameterdarstellung erreicht....
	;->index in r2
	;->decodierten parameter in adressierte position bergeben
	;->linksbndige darstellung zu position !
;_disSAMposOKx:		
;	cpi	r23,0x20	;hun
;	breq	_disSAMposOKbx
;	st	x+,r23
;	jmp	_disSAMposOKb
;_disSAMposOKbx:
;	adiw	xh:xl,1	;counter erhhen = akzuelle stelle nicht ndern
;_disSAMposOKb:
;	cpi	r24,0x20	;zeh
;	breq	_disSAMposOKcx
;	st	x+,r24
;	jmp	_disSAMposOKc
;_disSAMposOKcx:
;	adiw	xh:xl,1	;counter erhhen = akzuelle stelle nicht ndern
;_disSAMposOKc:
;	st	x,r25		;ein
	;
	;nun parametertabelle ergnzen
	;-> mit cntPAR adressieren == (paraACT)+(cntPAR*6)
	ldi	zh,high(paraACT)
	ldi	zl,low(paraACT)
	ldi	r23,6
	lds	r24,cntPARte
	mul	r23,r24
	add	zl,r0
	adc	zh,r1
	;zuerst text-index speichern
	st	z+,r2
	;parameter functionsvariable
	lds	r2,paraFUNC
	st	z+,r2
	;parameter position
	lds	r2,paraPOS
	st	z+,r2
	;dann parameter
	lds	r2,tePARx
	st	z+,r2
	;nun minimal/maximal-parameterrange
	lds	yh,comBUFadrH
	lds	yl,comBUFadrL

	ld	r2,y+	;minimalwert
	st	z+,r2
	ld	r2,y+	;maximalwert
	st	z+,r2
	;
_disBACKcheck:
	lds	yh,comBUFadrH
	lds	yl,comBUFadrL
	adiw	yh:yl,2
	;nun prfen ob letzter parameter
	;erreicht...
	inc	r24			;ist
	sts	cntPARte,r24	;& sichern
	lds	r23,cntPAR		;soll
	cp	r23,r24
	brne	_repPARAcalc	;weiter
	jmp	_disBACK		;fertig
_repPARAcalc:
	mov	zl,yl
	mov	zh,yh
	jmp	_disSAMparaLOOPa


	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;binrparameter nach ascii
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;ergebnis: 100er =r23 / 10er =r24 / 1er =r25
_paraKONascii:
	ldi	r16,0x30	;ascii 0
	clr	r2
	;
	lds	r22,tePAR
	cpi	r22,100
	brsh	_HUNloop
	ldi	r23,0x20	;space == keine hunderterstelle	
	jmp	_testTEN
_HUNloop:
	ldi	r19,100
	sub	r22,r19
	brcs	_lessHUN	
	inc	r2
	sts	tePAR,r22
	rjmp	_HUNloop
	;<100
_lessHUN:			;parameter <100
	add	r2,r16
	mov	r23,r2	;100 ascii wert in r23
	clr	r2
	lds	r22,tePAR
	;
_testTEN:
	cpi	r22,10
	brsh	_TENloop	
	;zehn =0 aber gibt's ne hunderterstelle?
	cpi	r23,0x30
	brsh	_testTENx	;ja!!!
	ldi	r24,0x20	;space == keine hunderterstelle
	jmp	_oneADD
_testTENx:
	ldi	r24,0x30	;0
	jmp	_oneADD

_TENloop:
	ldi	r19,10
	sub	r22,r19
	brcs	_lessTEN	
	inc	r2
	sts	tePAR,r22
	rjmp	_TENloop
	;<10
_lessTEN:			;parameter <10
	add	r2,r16
	mov	r24,r2	;10 ascii wert in r24
	clr	r2
	lds	r22,tePAR
_oneADD:
	add	r22,r16
	mov	r25,r22	;1 ascii wert in r25
	jmp	_disSAMparaLOOPb
	;
	;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	;
_disBACK:
	ret












;********************************************************************************************
;sub-copy flash / sram
;********************************************************************************************
;txt-tabellen format inkl. steuerbefehle:
;<maxINDEX(TXTstartadresse+0)>|<scrollDIR(TXTstartadresse+1>|<TEXT(ab TXTstartadresse+2>....|
;<FIELD(0=ende/15=newline)>|<INDEX(255=noINDEX/0-254=INDEX>
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_copySFa:
	lds	zh,TXTstartH	;flash startadresse
	lds	zl,TXTstartL
	ldi	xh,high(patxBUF)	;sram buffer startadresse
	ldi	xl,low(patxBUF)
	;zuerst die beiden steuerbytes
	;kopieren
	lpm	r16,z+
	st	x+,r16
	lpm	r16,z+
	st	x+,r16
	;jetzt text inklusive
	;steuerelementen kopieren
_copySFb:
	lpm	r16,z+
	st	x+,r16
	tst	r16
	breq	_copySFend		;0=textende
	cpi	r16,15		
	breq	_copySFline		;15=zeilenumbruch
	jmp	_copySFb
	;zeilenumbruch
_copySFline:
	;->index kopieren & weiter
	lpm	r16,z+
	st	x+,r16
	jmp	_copySFb
	;
	;textende
_copySFend:
	;->last index kopieren & ende
	lpm	r16,z
	st	x,r16
	ret



;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
_sysIFback:
	ret


